/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

register("OX_Configuration_Loaded", function() {
	var configerrors=false;
	try {
		if (typeof(config.gui) == "string") {
			config.gui = eval("(" + config.gui + ")");
		}
	} catch (e) {
		delete(config.gui);
		alert(format(_("Syntax error in config: \n%s"), e.message));
	}
	if (!configContainsKey("identifier") || !configContainsKey("contact_id")) {
		 configerrors=true;
		 alert(_("Configuration damaged, please inform the administrator."));
	} 
	if (!configContainsKey("language")) {
			configSetKey("language","de_DE");
	}
	if (!configContainsKey("timezone")) {
		configSetKey("timezone","Europe/Berlin");
	}
	if (!configContainsKey("folder"))  {
		configSetKey("folder",{});	
	}	
 	if (!configContainsKey("modules.tasks.notifyNewModifiedDeleted")) {
		configSetKey("modules.tasks.notifyNewModifiedDeleted",false);
    }
    if (!configContainsKey("modules.tasks.notifyAcceptedDeclinedAsCreator")) {
    	configSetKey("modules.tasks.notifyAcceptedDeclinedAsCreator",true);
    }
    if (!configContainsKey("modules.tasks.notifyAcceptedDeclinedAsParticipant")) {
    	configSetKey("modules.tasks.notifyAcceptedDeclinedAsParticipant",true);
    }
	if(!configContainsKey("mail.deletemail")) {
		configSetKey("mail.deletemail",false);	
	}	
	if(!configContainsKey("gui.menu.menuiteration")) {
		configSetKey("gui.menu.menuiteration",4);
	}
	if(!configContainsKey("gui.mail.notifyacknoledge")) {
		configSetKey("gui.mail.notifyacknoledge",true);
	}
	if(!configContainsKey("gui.mail.select_first_message")) {
        configSetKey("gui.mail.select_first_message",true);
    }
	if(!configContainsKey("mail.appendmailtext")) {
		configSetKey("mail.appendmailtext",true);
	}
	if(!configContainsKey("mail.inlineattachments")) {
		configSetKey("mail.inlineattachments",true);
	}
	if(!configContainsKey("gui.mail.htmlmessage")) {
		configSetKey("gui.mail.htmlmessage",true);
	}
	if(!configContainsKey("mail.vcard")) {
		configSetKey("mail.vcard",false);
	}
	if(!configContainsKey("mail.colorquoted")) {
		configSetKey("mail.colorquoted",false);
	}
	if(!configContainsKey("mail.emoticons")) {
		configSetKey("mail.emoticons",false);
	}
	if(!configContainsKey("gui.mail.formatmessage")) {
		configSetKey("gui.mail.formatmessage","ALTERNATIVE")
	} else if(configGetKey("gui.mail.formatmessage") == "text") {
		configSetKey("gui.mail.formatmessage","ALTERNATIVE")
	}
	if(!configContainsKey("gui.mail.autocomplete")) {
		configSetKey("gui.mail.autocomplete",true)
	}
	if(!configContainsKey("mail.forwardmessage")) {
		configSetKey("mail.forwardmessage","Inline");
	}
	if(!configContainsKey("mail.linewrap")) {
		configSetKey("mail.linewrap",70)
	}
	if(!configContainsKey("gui.calendar.interval")) {
		configSetKey("gui.calendar.interval",30);
	}
	if(!configContainsKey("gui.calendar.starttime")) {
		configSetKey("gui.calendar.starttime",8);
	}
	if(!configContainsKey("gui.calendar.endtime")) {
		configSetKey("gui.calendar.endtime",18);
	}
	if(!configContainsKey("gui.calendar.default_reminder")) {
		configSetKey("gui.calendar.default_reminder",15);
	}
	if(!configContainsKey("gui.calendar.view")) {
		configSetKey("gui.calendar.view","calendar/calendar/day");
	} else if(!(configGetKey("modules.calendar.calendar_freebusy") && configGetKey("modules.calendar.calendar_teamview"))) {
		var myconf=configGetKey("gui.calendar.view");
		if(myconf == "calendar/team/day" && myconf == "calendar/team/workweek") {
			configSetKey("gui.calendar.view","calendar/calendar/day");
		}
	}
	if(!configContainsKey("gui.calendar.allfolders")) {
		configSetKey("gui.calendar.allfolders",true);
	}
	if(!configContainsKey("gui.calendar.day.numberofappointments")) {
		configSetKey("gui.calendar.day.numberofappointments",4);
	}
	if(!configContainsKey("gui.calendar.workweek.numberofappointments")) {
		configSetKey("gui.calendar.workweek.numberofappointments",2);
	}
	if(!configContainsKey("gui.calendar.workweek.startday")) {
		configSetKey("gui.calendar.workweek.startday",1);
	}
	if(!configContainsKey("gui.calendar.workweek.countdays")) {
		configSetKey("gui.calendar.workweek.countdays",5);
	}
	if(!configContainsKey("gui.calendar.custom.countdays")) {
		configSetKey("gui.calendar.custom.countdays",3);
	}
	if(!configContainsKey("gui.calendar.custom.numberofappointments")) {
		configSetKey("gui.calendar.custom.numberofappointments",3);
	}
   if (!configContainsKey("modules.calendar.notifyNewModifiedDeleted")) {
        configSetKey("modules.calendar.notifyNewModifiedDeleted",false);
    }
    if (!configContainsKey("modules.calendar.notifyAcceptedDeclinedAsCreator")) {
        configSetKey("modules.calendar.notifyAcceptedDeclinedAsCreator",true);
    }  
    if (!configContainsKey("modules.calendar.notifyAcceptedDeclinedAsParticipant")) {
        configSetKey("modules.calendar.notifyAcceptedDeclinedAsParticipant",true);
    }
	if(!configContainsKey("gui.contacts.view")) {
		configSetKey("gui.contacts.view","contacts/cards");
	}
	if(!configContainsKey("gui.infostore.view")) {
		configSetKey("gui.infostore.view","infostore/split");
	}
	if(!configContainsKey("gui.mail.view")) {
		configSetKey("gui.mail.view","mail/hsplit/unthreaded");
	}
	if(!configContainsKey("gui.mail.signatures")) {
		configSetKey("gui.mail.signatures",new Array());
	}
	if(!configContainsKey("reloadtimes")) {
		configSetKey("reloadtimes",[0]);		
	}
	if(!configContainsKey("gui.global.autorefresh")) {
		configSetKey("gui.global.autorefresh",10);
	} else {
		var isvalid=false;
		var myrel=configGetKey("reloadtimes");		
		for(var i=0;i<myrel.length;i++) {
			if(configGetKey("gui.global.autorefresh")*60000==myrel[i]) {
				isvalid=true;
				break;
			}
		}
		if(!isvalid) {
			configSetKey("gui.global.autorefresh",0);
		}
	}
	if(!configContainsKey("gui.portal.tooltip")) {
		configSetKey("gui.portal.tooltip",false);
	}
	if(!configContainsKey("gui.portal.minicalendar")) {
		configSetKey("gui.portal.minicalendar",true);
	}
	if(!configContainsKey("gui.effects.hover.portal")) {
		configSetKey("gui.effects.hover.portal",true);
	}
	if(!configContainsKey("gui.effects.hover.mail")) {
		configSetKey("gui.effects.hover.mail",false);
	}
	if(!configContainsKey("gui.effects.hover.calendar")) {
		configSetKey("gui.effects.hover.calendar",true);
	}
	if(!configContainsKey("gui.effects.hover.contacts")) {
		configSetKey("gui.effects.hover.contacts",true);
	}
	if(!configContainsKey("gui.effects.hover.tasks")) {
		configSetKey("gui.effects.hover.tasks",true);
	}
	if(!configContainsKey("gui.effects.hover.infostore")) {
		configSetKey("gui.effects.hover.infostore",true);
	}
	if(!configContainsKey("gui.effects.hover.speed")) {
		configSetKey("gui.effects.hover.speed",3);
	}
	if(!configContainsKey("gui.effects.global")) {
		configSetKey("gui.effects.global",false);
		configSetKey("gui.effects.fading",false);
	}
	if(!configContainsKey("gui.portal.infobox")) {
		configSetKey("gui.portal.infobox",true);
	}
	if (!configContainsKey("global_categories")) {
		configSetKey("global_categories","");
	}
	if (!configContainsKey("gui.private_categories")) {
		configSetKey("gui.private_categories","");
	}
	if (!configContainsKey("gui.FolderTreeState")) {
		configSetKey("gui.FolderTreeState",new Object);
	}			
	if (!configContainsKey("gui.contacts.gridsort") || !isNaN(configGetKey("gui.contacts.gridsort")))   {
		configSetKey("gui.contacts.gridsort","last_name");
	}
	if (!configContainsKey("gui.contacts.gridorder")) {
		configSetKey("gui.contacts.gridsort","asc");
	}			
	if (!configContainsKey("gui.contacts.cardsToViewPerColumn")) {
		configSetKey("gui.contacts.cardsToViewPerColumn","auto");
	}
	if (!configContainsKey("gui.tasks.view")) {
		configSetKey("gui.tasks.view","tasks/split");
	}
	if(!configContainsKey("gui.tasks.gridsort")) {
		configSetKey("gui.tasks.gridsort","200");
	}
	if(!configContainsKey("gui.tasks.gridorder")) {
		configSetKey("gui.tasks.gridsort","asc");
	}
	if(!configContainsKey("gui.tasks.interval")) {
		configSetKey("gui.tasks.interval",30);
	}
	if(!configContainsKey("gui.global.save")) {
		configSetKey("gui.global.save",1);
	}
	if(!configContainsKey("gui.global.confirmpopup")) {
		configSetKey("gui.global.confirmpopup",true);
	} else {
		var id=configGetKey("gui.global.save");
		if(id != 0 && id != 1 && id != 2) {
			configSetKey("gui.global.save",2);
		}
	}
	if(!configContainsKey("gui.portal.internalcontents")) {
		configSetKey("gui.portal.internalcontents",new Array());
	}
	if(!configContainsKey("gui.portal.externalcontents")) {
		configSetKey("gui.portal.externalcontents",new Array());
	}
	triggerEvent("OX_Configuration_Set_Empty");
});
registerModule("configuration", "Configuration",100); /*i18n*/
function configuration_changed() {
	for (var i in configuration_changed_fields) {
		if(configuration_changed_fields[i] === true) 
			return true;
	}
	return false;
}
var configuration_changed_fields=new Object();
var configuration_changed_outside=false;
configuration_changed_fields["timezone"]=false;
configuration_changed_fields["language"]=false;
configuration_changed_fields["gui"]=false;
configuration_changed_fields["mail"]=false;
configuration_changed_fields["folder"]=false;
configuration_changed_fields["calendarnotification"]=false;
configuration_changed_fields["tasknotification"]=false;
configuration_changed_fields["modules"]=false;

var lastViewed = "";
var changed = new Array();
var changed_inv = false;
var foldersChanged = 0;
var j = 0;
var configVisited = false;

(function() {
	register("Loaded", function() {});
})();

//because already defined in configtree.js
/*
registerView("configuration",
	function (){},
	function() { 
	},
	function() {		
	},
	function() {
	},
	null
);*/
register("OX_Configuration_GUI_Changed",function () {
	configuration_changed_fields["gui"]=true;
});

/**
 * Asks the user to save changes before leaving a configuration page.
 * If the changes need to be saved, the event OX_SAVE_OBJECT is triggered.
 * If the changes should be discarded, the event OX_Cancel_Object is triggered.
 * @param {Function} callback An optional callback which is called if the page
 * change is not cancelled.
 */
function configuration_askforSave(callback) {
    if(configuration_changed()) {
        newConfirm(_("Configuration changed"),
            _("Do you want to save your configuration?"),
            AlertPopup.YESNO, null, null,
            function() {
                triggerEvent("OX_SAVE_OBJECT");
                if (callback) callback();
            },
            function() {
                triggerEvent("OX_Cancel_Object");
                if (callback) callback();
            });     
    } else {
        if(callback) callback();
    }
}

register("OX_Save_Configuration",configuration_saveObject);
function configuration_saveObject(force,hidemessage,myok,myerror,optParam) {
    var showmessage=true;
    var openrequests=0;
    var iserror=false;
    var errormessage="";
    
    function successcb(r) {
        openrequests--;
        if(openrequests==0) {
            afterRequest();
        }
    }
    if(!myok) {
        myok=successcb;
    }
    
    function errorcb(result,status) {
        openrequests--;
        iserror=true;
        if(status != 200) {
            errormessage=_("The configuration could not be saved, because of the following error:") +
                //#. HTTP Errors from the server
                //#. %1$s is the numeric HTTP status code
                //#. %2$s is the corresponding HTTP status text
                format(_("Error: %1$s - %2$s"), status, result);
        }
        if (openrequests==0) {
            afterRequest();
        }
    }
	if(!myerror) {
		myerror=errorcb;
	}

	function afterRequest() {
		if (iserror) {
			if(!hidemessage) triggerEvent("OX_New_Error",errormessage);
		} else {
			if(!hidemessage) {
				triggerEvent("OX_New_Info",4,_("Your settings have been saved"));
			}
			if (!force) {
				if(activemodule=="configuration") {
					triggerEvent("OX_Configuration_Changed",currentpath2.join("/"));
				} else {
					triggerEvent("OX_Configuration_Changed","");
				}
			}
		}
	}
	
	var ro_ConfigSettings = [ "folder", "defaultaddress", "addresses", "spambutton",
	                    "availableModules", "context_id", "global_categories",
	                    "reloadtimes", "folder", "identifier", "contact_id",
	                    "currentTime", "serverVersion", "maxUploadIdleTimeout",
	                    "mail.folder", "mail.defaultaddress", "mail.addresses",
	                    "mail.spambutton", "participants.showWithoutEmail",
	                    "participants.showDialog", "modules"
	                  ];
	
	function saveConfigtoServer(path,params,success1,error1,myjson) {
		showmessage=true;
		var reqstring=AjaxRoot + "/config";
		var myparams;
		if (path && path != "") {
			reqstring=reqstring+"/"+path;
		}
		reqstring=reqstring+"?session="+session;
		if (params && params != "") {
			myparams=configGetKey(params);
		} else {
			myparams=clone(config);
		}
        // going to remove read-only settings
		for (i in ro_ConfigSettings) {			
			var splitkey = ro_ConfigSettings[i].split(".");			
			var tmp = myparams;
			for (var ia=0; ia<splitkey.length-1; ia++) {
		        if (tmp[splitkey[ia]] != undefined) {
		            tmp=tmp[splitkey[ia]];
		        } else {
		            break;
		        }
		    }		       	            
            if (!splitkey || !splitkey.length) continue;
            delete tmp[splitkey[splitkey.length-1]];
		}
		myjson.put(reqstring, myparams, null, success1, error1);
	}
	var myjson=new JSON();
	if(force) {
		for (var i in configuration_changed_fields) {
			configuration_changed_fields[i] = false;
		}
		saveConfigtoServer("","",myok,myerror,myjson);
		configuration_changed_outside=false;
	}
	if(configuration_changed_fields["folder"] == true) {
		saveFolder(optParam);
		configuration_changed_fields["folder"]=false;
		showmessage=false;
	}
	if(configuration_changed_fields["mail"] == true) {
		saveConfigtoServer("mail","mail",myok,myerror,myjson);
		openrequests++;
		configuration_changed_fields["mail"] = false;
	}
	if(configuration_changed_fields["timezone"] == true) {
		saveConfigtoServer("timezone","timezone",myok,myerror,myjson);
		openrequests++;
		configuration_changed_fields["timezone"] = false;
	}
	if(configuration_changed_fields["language"] == true) {
		saveConfigtoServer("language","language",myok,myerror,myjson);
		openrequests++;
		configuration_changed_fields["language"] = false;
	}
	if(configuration_changed_fields["gui"] == true) {
		saveConfigtoServer("gui","gui",myok,myerror,myjson);
		openrequests++;
		configuration_changed_fields["gui"] = false;
	}
	if (configuration_changed_fields["tasknotification"] == true) {		
        delete(config["tasknotification"]);
		// todo: each modules section should have an own area later!!
		configuration_changed_fields["modules"] = true;
		configuration_changed_fields["tasknotification"] = false;
	}
	if (configuration_changed_fields["calendarnotification"] == true) {
		delete(config["calendarnotification"]);
		// todo: each modules section should have an own area later!!
        configuration_changed_fields["modules"] = true;
		configuration_changed_fields["calendarnotification"] = false;
	}
	if(configuration_changed_fields["modules"] == true) {
		saveConfigtoServer("modules","modules",myok,myerror,myjson);
		openrequests++;
		configuration_changed_fields["modules"] = false;
	}
    if (temporary.folderTabs.viewModified()) {
        temporary.folderTabs.saveView(function() {
            oMainFolderTree.cache.updateFolders(
                [temporary.folderTabs.folder.id],
                function() {
                    oMainFolderTree.load_view(
                        oMainFolderTree.cache.folders.root,
                        oMainFolderTree.tree, true, false);
                }); 
        });
        showmessage = false;
    }
	if(openrequests==0 && showmessage) {
		afterRequest();
	}
}

function selectValue(rObj, setValue) {
	var fieldValue = new Array();
	var j;
	for (var i=0; i < rObj.length; i++) {
		if (rObj[i].value == setValue) {
			j = i;
			break;
		} else {
			j = 0;
		}
	}
	return j;
}

function cancelConfigGUI() {
	if (cloned != "") {
		config = new Object();
		config = copy(cloned);
	}
	changed = new Array();
}

function displaySignatureConfig(val) {
	 sig = document.getElementById("signaturetext");
	 sig.value = val;
}

function LogoutPopup() { }
LogoutPopup.openWindow = emptyFunction;
LogoutPopup.closeWindow = emptyFunction;
LogoutPopup.commityes = function () {	
	triggerEvent("OX_Save_Configuration",true,true,function() {
		//NO ERROR
		window.onbeforeunload = null;
		new JSON().get(AjaxRoot + "/login?action=logout&session=" + session, null, function() {
			window.setTimeout( function() { window.location.replace(logout_location.format()); },0);
		},function() { 
			window.setTimeout( function() { window.location.replace(logout_location.format()); },0);			
			return true;
		});
	}, function(data) {
		window.onbeforeunload = null;
		if (typeof data != "object" || data.code == "SES-0203") {
			window.setTimeout( function() { 
				window.location.replace(logout_location.format()); 
			},0);
		} else {
			newConfirm(_("Server Error:"),_("Your configuration settings could not be saved. All your changes will be lost. Do you really want to continue?") + "\n\n" + formatError(data), AlertPopup.YESNO,null,null,
				function() {
					
					new JSON().get(AjaxRoot + "/login?action=logout&session=" + session, null, 
						function() { 
							window.setTimeout( function() { window.location.replace(logout_location.format()); },0);
						},
						function() { 
							window.setTimeout( function() {
								window.location.replace(logout_location.format()); 
							},0);			
							return true;
						});
				},
				emptyFunction
			);
		}
		return true;
	});
}
LogoutPopup.commitno = function () {
	window.onbeforeunload = null;
	(new JSON()).get(AjaxRoot + "/login?action=logout&session=" + session, null, function() {
		window.setTimeout( function() { window.location.replace(logout_location.format()); },0);
	},function() { 
		window.setTimeout( function() { window.location.replace(logout_location.format()); },0);
		return true;
	});
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var config_tags_categories_private=new Array();
var config_tags_currentcategory=-1;

registerView("configuration/tags",
	function() { 
		showNode("config_tags"); 
		$("config_tags").style.display="block"; },
	function() { 
 	    register("OX_SAVE_OBJECT",config_tags_saveConfiguration);
		register("OX_Cancel_Object",config_tags_cancelConfiguration);
		register("OX_Configuration_Categories_Add",config_tags_addCategory);
		register("OX_Configuration_Categories_Edit",config_tags_editCategory);
		register("OX_Configuration_Categories_Remove",config_tags_removeCategory);
		resizeEvents.register("Resized",setDynamicHeighConfigTag);
		config_tags_enter(); 
	},
	function() { 
		//configuration_askforSave();
 	    unregister("OX_SAVE_OBJECT",config_tags_saveConfiguration);
		unregister("OX_Cancel_Object",config_tags_cancelConfiguration);
		unregister("OX_Configuration_Categories_Add",config_tags_addCategory);
		unregister("OX_Configuration_Categories_Edit",config_tags_editCategory);
		unregister("OX_Configuration_Categories_Remove",config_tags_removeCategory);
		resizeEvents.unregister("Resized",setDynamicHeighConfigTag);

		config_tags_leave();
	},
	function() { 
		hideNode("config_tags"); 
		$("config_tags").style.display="none"; },
	function() { config_tags_enter(); }
);

function config_tags_saveConfiguration() {
	if(configuration_changed_fields["gui"]) {
 		configSetKey("gui.private_categories",config_tags_categories_private.join(","));
	}
	triggerEvent("OX_Save_Configuration",false,false);
} 
function config_tags_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	config_tags_enter();
} 
function config_tags_enter () {
	config_tags_categories_private=new Array();
	if(configContainsKey("gui.private_categories") && configGetKey("gui.private_categories")!="") {
		config_tags_categories_private=configGetKey("gui.private_categories").split(",");
	}
	config_tags_fillCategory();
	if(config_tags_categories_private.length>0) {
		config_tags_selectCategory(document.getElementById("Tag-0"));
	}
	$("config_tags_header").firstChild.nodeValue=getconfigPathSelected().substring(1);
}
function config_tags_leave() {
}
function setDynamicHeighConfigTag() {
	$("cs_parenttable_categories_private").style.height = $("cs_parenttable_categories_private").parentNode.offsetHeight -1 + "px";
}
function checkDuplicate(myname) {
	for(var i=0;i<config_tags_categories_private.length;i++) {
		if(config_tags_categories_private[i]==myname) return true;
	}
	return false;
}
function config_tags_addCategory() {	
	openTagsWindow("",config_tags_newCategory, null, true);
}
function config_tags_editCategory() {	
	openTagsWindow(config_tags_categories_private[config_tags_currentcategory],config_tags_changeCategory);
}
function ConfigTags() {
	this.cbok;
	this.cbcancel;
}
ConfigTags.open = function () {
	showNode("disable_background_window");
	$("disable_background_window").style.display="block";
	showNode("config_popups_win");
	$("config_popups_win").style.display="block";
	showNode("window_tags");
	centerPopupWindow($("window_tags"));
	$("window_tags").style.display="block";
	$("tags_window_tags_input").focus();
}
ConfigTags.close = function () {
	if(this.closecb) { globalalert.cbclose(); }
	hideNode("window_tags");
	$("window_tags").style.display="none";
	hideNode("config_popups_win");
	$("config_popups_win").style.display="none";
	var childs=	$("disable_background_window").childNodes;
	var closeall=true;
	for(var i=0;i<childs.length;i++) {
		if(childs[i].tagName && childs[i].tagName == "DIV") {
			if(childs[i].style.display && childs[i].style.display!= "none" ) {
				closeall=false;
			}
		}
	}
	if(closeall) {
		hideNode("disable_background_window");
		$("disable_background_window").style.display="none";
	}
}
ConfigTags.commitcancel = function () {
	if(configtags.cbcancel) { configtags.cbcancel(); }
	ConfigTags.close();
}
ConfigTags.commitok = function () {
	if (!$("tags_window_tags_input").value) return;
	if(configtags.cbok) { configtags.cbok(); }
	ConfigTags.close();
}

ConfigTags.change = function() {
	setTimeout(function() {
		$("tags_window_tags_ok").style.color =
			$("tags_window_tags_input").value ? "black" : "#aaaaaa";
	}, 0);
}

register("Loaded", function () {
	addOnClose($("window_tags"),function() { ConfigTags.close() }); 
	}
);
var configtags=new ConfigTags();
function openTagsWindow(tagnamevalue,cbok,cbcancel, isNew) {
	$("tags_window_tags_input").value=tagnamevalue;
	ConfigTags.change();
	$("window_tags.prompt").firstChild.data = isNew ? _("New Tag:")
	                                                : _("Edit Tag:");
	configtags.cbok=cbok;
	configtags.cbcancel=cbcancel;
	ConfigTags.open();
} 
function config_tags_newCategory() {
	var tmptag=$("tags_window_tags_input").value;
	if(checkDuplicate(tmptag)) {
		triggerEvent("OX_New_Error",4,_("This Tag already exists in your private tag list"));
	} else {
		config_tags_categories_private.push(tmptag);
		configuration_changed_fields["gui"]=true;
		config_tags_fillCategory();
		config_tags_selectCategory(document.getElementById("Tag-"+(config_tags_categories_private.length-1)));
	}
}
function config_tags_changeCategory() {
	var tmptag=$("tags_window_tags_input").value;
	if(checkDuplicate(tmptag)) {
		if(tmptag!=config_tags_categories_private[config_tags_currentcategory]) {
			triggerEvent("OX_New_Error",4,_("This Tag already exists in your private tag list"));
		}
	} else {
		config_tags_categories_private[config_tags_currentcategory]=tmptag;
		configuration_changed_fields["gui"]=true;
		config_tags_fillCategory();
		config_tags_selectCategory(document.getElementById("Tag-"+(config_tags_currentcategory)));
	}
}
function config_tags_removeCategory() {
	config_tags_categories_private.splice(parseInt(config_tags_currentcategory),1);
	config_tags_fillCategory();
	if(config_tags_categories_private.length>0) {
		config_tags_selectCategory(document.getElementById("Tag-0"));
	}
	configuration_changed_fields["gui"]=true;
}

function config_tags_fillCategory() {
	removeChildNodes($("cs_categories_private"));
	for(var i=0;i<config_tags_categories_private.length;i++) {
		var newcat=$("cs_template_private_row").cloneNode("false");
		var textnode=document.createTextNode(config_tags_categories_private[i]);
		newcat.id="Tag-"+i;
		newcat.appendChild(textnode);
		$("cs_categories_private").appendChild(newcat);	
	}
	triggerEvent("SubSelected",0);	
}
function config_tags_selectCategory(param) {
	var allcategories = param.parentNode.getElementsByTagName("div");
	for (var i=0;i<allcategories.length;i++) {
		allcategories[i].className = removeClass(allcategories[i].className,"background-color-PMG-selection-elements");
	}
	param.className += " background-color-PMG-selection-elements";
	config_tags_currentcategory=param.id.split("-")[1];
	triggerEvent("SubSelected",1);	
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

register("OX_Configuration_Settings_Changed_Language",cs_changedLanguage);
register("OX_Configuration_Settings_Changed_Timezone",cs_changedTimezone);
register("OX_Configuration_Settings_Changed_GUI",cs_changedGui);
register("OX_Configuration_Settings_Changed_Mail",cs_changedMail);
register("OX_Configuration_Settings_Changed_Modules",cs_changedModules);
register("OX_Configuration_Settings_Changed_Calendar_Notification",cs_changedCalendarNotification);
register("OX_Configuration_Settings_Changed_Task_Notification",cs_changedTaskNotification);
register("OX_Configuration_Settings_Changed_Region_Date", cs_region_date_changed);

function cs_changedMail() {
	configuration_changed_fields["mail"]=true;
}
function cs_changedModules() {
	configuration_changed_fields["modules"]=true;
}
function cs_changedGui() {
	configuration_changed_fields["gui"]=true;
}
function cs_changedTimezone() {
	configuration_changed_fields["timezone"]=true;
}
function cs_changedLanguage() {
	configuration_changed_fields["language"]=true;
}
function cs_changedCalendarNotification() {
	configuration_changed_fields["calendarnotification"]=true;
}
function cs_changedTaskNotification() {
	configuration_changed_fields["tasknotification"]=true;
}
function getBoolofInt(myint) {
	if(myint!=0) 
		return true;
	return false;
}
function getValueofRadioBox(nameofradios) {
	var allelements = document.getElementsByName(nameofradios);
	var returnvalue = 0;
	for (var i=0; i<allelements.length; i++) {
		if (allelements[i].checked) {
			return parseInt(allelements[i].value);
		} 
	}
}
function getStringofRadioBox(nameofradios) {
	var allelements = document.getElementsByName(nameofradios);
	var returnvalue = 0;
	for (var i=0; i<allelements.length; i++) {
		if (allelements[i].checked) {
			return allelements[i].value;
		} 
	}
}
function setIntofRadioBox(nameofradios,value){
	var allelements = document.getElementsByName(nameofradios);
	for (var i=0; i<allelements.length; i++) {
		if (parseInt(allelements[i].value) == value) {
			allelements[i].checked=true;
			break;
		} 
	}
}
function setValueofRadioBox(nameofradios,value) {
	if(value==true) { value=1; }
	if(value==false) { value=0; }
	var allelements = document.getElementsByName(nameofradios);
	for (var i=0; i<allelements.length; i++) {
		if (parseInt(allelements[i].value) == value) {
			allelements[i].checked=true;
			break;
		} 
	}
}
function setStringofRadioBox(nameofradios,value) {
	if(value==true) { value=1; }
	if(value==false) { value=0; }
	var allelements = document.getElementsByName(nameofradios);
	for (var i=0; i<allelements.length; i++) {
		if (allelements[i].value == value) {
			allelements[i].checked=true;
			break;
		} 
	}
}
registerView("configuration/settings",
	function() { 
		showNode("config"); 
		$("config").style.display="block";
	},
		
	function() { 
 	    register("OX_SAVE_OBJECT",cs_saveConfiguration);
		register("OX_Cancel_Object",cs_cancelConfiguration);
		register("LanguageChanged",cs_changeHeader);
		//init config
		markConfigTreeNode('configuration/settings');
		cs_enter(); 
        changeTab('tabConfiguration1', 'panelConfiguration1');
        $("panelConfiguration1").className="tabPanelFirstHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";        
		cs_region_enter();
	},
	function() { 
		//configuration_askforSave();
 	    unregister("OX_SAVE_OBJECT",cs_saveConfiguration);
		unregister("OX_Cancel_Object",cs_cancelConfiguration);
		unregister("LanguageChanged",cs_changeHeader);
		cs_leave();
	},
	function() { 
		hideNode("config"); 
		$("config").style.display="none";
		$("tabConfiguration1").style.display="none";
		$("panelConfiguration1").className="tabPanelFirst tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";
	
	},
	function() { 
		cs_enter();
		cs_region_enter(); 
	}
);

function cs_changeHeader() {
	if(currentpath2.join("/") == "configuration/settings") {
		$("cs_header").firstChild.nodeValue=getconfigPathSelected().substring(1);
	}
}

var configSettingsTabsList = new Array('tabConfiguration1','tabConfiguration2');
var configSettingsPanelsList = new Array('panelConfiguration1','panelConfiguration2');
var configSettingsEventList = null;
	
function cs_saveConfiguration() {
	if(configuration_changed_fields["timezone"]) {
		configSetKey("timezone",cs_timezone.getKey());
	}
	if(configuration_changed_fields["language"]) {
		configSetKey("language",cs_language.getKey());
		setLanguage(configGetKey("language"));
		cs_region_enter();
	}
	if (configuration_changed_fields["gui"]) {		
		var selectedTheme = cs_theme.getKey();		
		if (selectedTheme != configGetKey("gui.theme").path && configContainsKey("modules.themes." + selectedTheme)) {
			triggerEvent("OX_New_Info",4,_("Theme will be applied after a new login."/*i18n*/));
			configSetKey("gui.theme", { name: configGetKey("modules.themes")[selectedTheme], path: selectedTheme });
		}
		
		var selectedPage = cs_landingPage.getKey();		
		if (selectedPage) {
			configSetKey("gui.global.landing_page", { module: selectedPage });
		}
			
 		configSetKey("gui.global.save",getValueofRadioBox("cs_saveconfig"));
		configSetKey("gui.global.autorefresh",cs_autorefresh.getKey());
		configSetKey("gui.portal.tooltip",getBoolofInt(getValueofRadioBox("cs_showquickinfo")));
		configSetKey("gui.portal.infobox",getBoolofInt(getValueofRadioBox("cs_showinfobox")));
		configSetKey("gui.portal.minicalendar",getBoolofInt(getValueofRadioBox("cs_showminicalendar")));
		configSetKey("gui.effects.fading",getBoolofInt(getValueofRadioBox("cs_enableeffects")));
		configSetKey("gui.effects.global",getBoolofInt(getValueofRadioBox("cs_enableeffects")));
		configSetKey("gui.effects.hover.portal",getBoolofInt(getValueofRadioBox("cs_enablehoverportal")));
		configSetKey("gui.effects.hover.mail",getBoolofInt(getValueofRadioBox("cs_enablehovermail")));
		configSetKey("gui.effects.hover.calendar",getBoolofInt(getValueofRadioBox("cs_enablehovercalendar")));
		configSetKey("gui.effects.hover.contacts",getBoolofInt(getValueofRadioBox("cs_enablehovercontacts")));
		configSetKey("gui.effects.hover.tasks",getBoolofInt(getValueofRadioBox("cs_enablehovertasks")));
		configSetKey("gui.effects.hover.infostore",getBoolofInt(getValueofRadioBox("cs_enablehoverinfostore")));
		configSetKey("gui.effects.hover.speed",getValueofRadioBox("cs_hoverspeed"));	
		configSetKey("gui.global.region.time.predefined",getValueofRadioBox("cs_time_predefined"));
		if(getValueofRadioBox("cs_time_predefined") == 0) {
			if($("cs_time_userdefined:0").checked) {
				configSetKey("gui.global.region.time.format", "hh:mm a");
				configSetKey("gui.global.region.time.format_hour", "hh a");
				configSetKey("gui.global.region.time.format_suffix", true);
			}
			else {				
				configSetKey("gui.global.region.time.format", "HH:mm");
				configSetKey("gui.global.region.time.format_hour", "HH:mm");
				configSetKey("gui.global.region.time.format_suffix", false);
			}
		}
		configSetKey("gui.global.region.date.predefined",getValueofRadioBox("cs_date_predefined"));
		if(getValueofRadioBox("cs_date_predefined") == 0) {
			configSetKey("gui.global.region.date.format_selected_index", cs_dateformat.getSelectedIndex());
			configSetKey("gui.global.region.date.separator", cs_date_separator.getKey());
			var current_date_separator = cs_date_separator.getKey();
			var current_date_format = cs_dateformat.getKey();
			if(current_date_separator && current_date_separator != "default") {
				current_date_format = current_date_format.replace(/\W/g,current_date_separator);
			}
			configSetKey("gui.global.region.date.format", current_date_format);
		}
	}
	triggerEvent("OX_Save_Configuration",false,false);
}

function cs_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	configuration_changed_fields["language"]=false;
	configuration_changed_fields["timezone"]=false;
	cs_enter();	
}

function cs_region_enter() {
	/* time format */
	if(configContainsKey("gui.global.region.time.predefined") && configGetKey("gui.global.region.time.predefined")==0) {
		$("cs_time_userdefined:0").disabled = false;
		$("cs_time_userdefined:1").disabled = false;
		$("cs_time_predefined:0").checked = true
		var current_time_format = configGetKey("gui.global.region.time.format");
	} else {
		$("cs_time_userdefined:0").disabled = true;
		$("cs_time_userdefined:1").disabled = true;
		$("cs_time_predefined:1").checked = true
		var current_time_format = _("HH:mm");
	}
	if(current_time_format.indexOf("a") != -1) {
		$("cs_time_userdefined:0").checked = true;
	} else {
		$("cs_time_userdefined:1").checked = true;
	}
	$("cs_region_time_sample").value = formatDate(new Date(now()), "time");
	
	
	/* date format */
	if(configContainsKey("gui.global.region.date.predefined") && configGetKey("gui.global.region.date.predefined")==0) {
		$("cs_date_predefined:0").checked = true
		var triggerNoEvent = true;
		cs_dateformat.setSelectedIndex(configGetKey("gui.global.region.date.format_selected_index"),triggerNoEvent);
		cs_date_separator.setKey(configGetKey("gui.global.region.date.separator"),triggerNoEvent);
		cs_dateformat.enable();
		cs_date_separator.enable();
	} else {
		cs_dateformat.disable();
		cs_date_separator.disable();
		$("cs_date_predefined:1").checked = true
	}
	$("cs_region_date_sample").value = formatDate(new Date(now()), "date");
}

function cs_region_set_time_format() {
	if($("cs_time_predefined:0").checked == true) {
		$("cs_time_userdefined:0").disabled = false;
		$("cs_time_userdefined:1").disabled = false;	
		var current_time_format = ($("cs_time_userdefined:0").checked) ? "hh:mm a" : "HH:mm";
		
	} else {
		$("cs_time_userdefined:0").disabled = true;
		$("cs_time_userdefined:1").disabled = true;
		var current_time_format = _("HH:mm");
		if(current_time_format.indexOf("a") != -1) {
			$("cs_time_userdefined:0").checked = true;
		} else {
			$("cs_time_userdefined:1").checked = true;
		}
	}
	$("cs_region_time_sample").value = formatDateTime(current_time_format, new Date(now()));
}

function cs_region_set_date_format() {
	if($("cs_date_predefined:0").checked == true) {
		cs_dateformat.enable();
		cs_date_separator.enable();
		var current_date_format = cs_dateformat.getKey();	
		var current_date_separator = cs_date_separator.getKey();	
	} else {
		cs_dateformat.disable();
		cs_date_separator.disable();
		var current_date_format = _("yyyy-MM-dd");
		var current_date_separator = false;
	}
	if(current_date_separator && current_date_separator != "default") {
		current_date_format = current_date_format.replace(/\W/g,current_date_separator);
	}
	$("cs_region_date_sample").value = formatDateTime(current_date_format, new Date(now()));
}

function cs_region_date_changed() {
	triggerEvent('OX_Configuration_Settings_Changed_GUI');
	cs_region_set_date_format()
}

function cs_enter() {	
	if(!cs_init_bool) {
		cs_init();
		cs_init_bool=true;
	}
	if(configContainsKey("language")) {
		cs_language.setKey(configGetKey("language"));
		configuration_changed_fields["language"]=false;
	}	
	if(configContainsKey("timezone")) {
		cs_timezone.setKey(configGetKey("timezone"));
		configuration_changed_fields["timezone"]=false;
	}
	if(configContainsKey("gui.theme")) {
		cs_theme.setKey(configGetKey("gui.theme").path);
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.global.landing_page")) {
		cs_landingPage.setKey(configGetKey("gui.global.landing_page").module);
		configuration_changed_fields["gui"]=false;
	}
	cs_autorefresh.setKey(configGetKey("gui.global.autorefresh"));
	if (configContainsKey("gui.global.save")) {
		var id = configGetKey("gui.global.save");
		setIntofRadioBox("cs_saveconfig", id);
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.portal.tooltip")) {
		setIntofRadioBox("cs_showquickinfo",configGetKey("gui.portal.tooltip"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.portal.infobox")) {
		setIntofRadioBox("cs_showinfobox",configGetKey("gui.portal.infobox"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.global")) {
		setIntofRadioBox("cs_enableeffects",configGetKey("gui.effects.global"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.portal.minicalendar")) {
		setIntofRadioBox("cs_showminicalendar",configGetKey("gui.portal.minicalendar"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.portal")) {
		setIntofRadioBox("cs_enablehoverportal",configGetKey("gui.effects.hover.portal"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.mail")) {
		setIntofRadioBox("cs_enablehovermail",configGetKey("gui.effects.hover.mail"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.calendar")) {
		setIntofRadioBox("cs_enablehovercalendar",configGetKey("gui.effects.hover.calendar"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.contacts")) {
		setIntofRadioBox("cs_enablehovercontacts",configGetKey("gui.effects.hover.contacts"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.tasks")) {
		setIntofRadioBox("cs_enablehovertasks",configGetKey("gui.effects.hover.tasks"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.infostore")) {
		setIntofRadioBox("cs_enablehoverinfostore",configGetKey("gui.effects.hover.infostore"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.speed")) {
		setIntofRadioBox("cs_hoverspeed",configGetKey("gui.effects.hover.speed"));
		configuration_changed_fields["gui"]=false;
	}
	$("cs_header").firstChild.nodeValue=getconfigPathSelected().substring(1);
	setTabLists(configSettingsTabsList, configSettingsPanelsList, null);
} 

function cs_enableallhover() {
		setIntofRadioBox("cs_enablehoverportal",1);
		setIntofRadioBox("cs_enablehovermail",1);
		setIntofRadioBox("cs_enablehovercalendar",1);
		setIntofRadioBox("cs_enablehovercontacts",1);
		setIntofRadioBox("cs_enablehovertasks",1);
		setIntofRadioBox("cs_enablehoverinfostore",1);
		configuration_changed_fields["gui"]=true;
}

function cs_disableallhover() {
		setIntofRadioBox("cs_enablehoverportal",0);
		setIntofRadioBox("cs_enablehovermail",0);
		setIntofRadioBox("cs_enablehovercalendar",0);
		setIntofRadioBox("cs_enablehovercontacts",0);
		setIntofRadioBox("cs_enablehovertasks",0);
		setIntofRadioBox("cs_enablehoverinfostore",0);
		configuration_changed_fields["gui"]=true;
}

function cs_init() {
    if(!configGetKey("modules.portal.module")) { $("cs_portal_hover").style.display="none"; }
    if(!configGetKey("modules.mail.module")) { $("cs_mail_hover").style.display="none"; }
    if(!configGetKey("modules.calendar.module")) { $("cs_calendar_hover").style.display="none"; }
    if(!configGetKey("modules.contacts.module")) { $("cs_contacts_hover").style.display="none"; }
    if(!configGetKey("modules.tasks.module")) { $("cs_tasks_hover").style.display="none"; }
    if(!configGetKey("modules.infostore.module")) { $("cs_infostore_hover").style.display="none"; }
	
	var myarray=configGetKey("reloadtimes");
	cs_autorefresh = new ComboBox3(window, "cs_autorefresh", "15em", 0, true,"OX_Configuration_Settings_Changed_GUI", 3);
	cs_autorefresh.addElement("Never",0);/*i18n*/
	var mTmp = function(n) { return function() { return getInterval(n); }; };
	if(configContainsKey("reloadtimes")) {
		for(var i=0;i<myarray.length;i++) {
			if(!myarray[i]== 0) {
				cs_autorefresh.addElement("",(myarray[i]/60000),mTmp(myarray[i]));
			}
		}
	}
	cs_autorefresh.getDomNode();
	
	// fake cb to prevent combobox translation 
	function cb_tmpLang(element) {
		return function() {
			return element;
		}
	}
	
	cs_language = new ComboBox3(window, "cs_language", "15em", 0, true, "OX_Configuration_Settings_Changed_Language", 3);
	for(var i in corewindow.all_languages) {
		if (i) cs_language.addElement(corewindow.all_languages[i], i,
		                       cb_tmpLang(corewindow.all_languages[i]));	
	}
	cs_language.getDomNode();
	
	cs_timezone = new ComboBox3(window, "cs_timezone", "25em", 1, true, "OX_Configuration_Settings_Changed_Timezone", 8);
	for(var i=0;i<timezones.length;i++) {
		cs_timezone.addElement(timezones[i], timezones[i].replace(/ /g, "_"));	
	}
	cs_timezone.getDomNode();
	
	cs_dateformat = new ComboBox3(window, "cs_dateformat", "9em", 0, true, "OX_Configuration_Settings_Changed_Region_Date", 8);
	cs_dateformat.addElement("M/d/yyyy"/*i18n*/, 	"M/d/yyyy");
	cs_dateformat.addElement("M/d/yy"/*i18n*/, 		"M/d/yy");
	cs_dateformat.addElement("MM/dd/yy"/*i18n*/, 	"MM/dd/yy");
	cs_dateformat.addElement("MM/dd/yyyy"/*i18n*/, 	"MM/dd/yyyy");
	cs_dateformat.addElement("yy/MM/dd"/*i18n*/, 	"yy/MM/dd");
	cs_dateformat.addElement("dd/MM/yyyy"/*i18n*/, 	"dd/MM/yyyy");
	cs_dateformat.addElement("dd/MM/yy"/*i18n*/, 	"dd/MM/yy");
	cs_dateformat.addElement("dd.MM.yyyy"/*i18n*/,	"dd.MM.yyyy");	
	cs_dateformat.addElement("dd.MM.yy"/*i18n*/, 	"dd.MM.yy");
	cs_dateformat.addElement("d.MM.yy"/*i18n*/, 	"d.MM.yy");
	cs_dateformat.addElement("d.M.yy"/*i18n*/, 		"d.M.yy");
	cs_dateformat.addElement("d.M.yyyy"/*i18n*/, 	"d.M.yyyy");
	cs_dateformat.addElement("yyyy-MM-dd", 	"yyyy-MM-dd",
        function() { return pgettext("label", "yyyy-MM-dd"); });
	cs_dateformat.addElement("dd-MMM-yy"/*i18n*/, 	"dd-MMM-yy");
	cs_dateformat.getDomNode();
	
	cs_date_separator = new ComboBox3(window, "cs_dateseparator", "9em", 0, true, "OX_Configuration_Settings_Changed_Region_Date", 3);
	cs_date_separator.addElement("default"/*i18n*/, 	"default");
	cs_date_separator.addElement("/", 				"/");
	cs_date_separator.addElement(".", 				".");
	cs_date_separator.addElement("-", 				"-");
	cs_date_separator.getDomNode();
    
    var themes = [];
    var themeconfig = configGetKey("modules.themes");
    if (themeconfig) {
    	for (i in themeconfig) {
    		themes.push({ name: themeconfig[i], path: i });
    	}
        themes.sort(function(a, b) { 
        	   return (a.name.toUpperCase() < b.name.toUpperCase() ? -1 : 1); 
        	});
    } else {
        themes.push({ name: "Default", path: "default" });
    }
    
	cs_theme = new ComboBox3(window, "cs_theme", "30em", 0, true, "OX_Configuration_Settings_Changed_GUI", 3);
	for(var i=0;i<themes.length;i++) {
		cs_theme.addElement(themes[i].name, themes[i].path);	
	}	
    cs_theme.getDomNode();
    
    
	cs_landingPage = new ComboBox3(window, "cs_landing_page", "30em", 0, true, "OX_Configuration_Settings_Changed_GUI", 3);
	for(var i in modules) {
		if (modules[i].disable == false && modules[i].name != "configuration") {
			cs_landingPage.addElement(modules[i].text, modules[i].name);
		}
	}	
	cs_landingPage.getDomNode();
}

function cs_leave() { }
var cs_init_bool=false;
var cs_language;
var cs_autorefresh;
var cs_timezone;
var cs_theme;
var cs_landingPage;
var cs_dateformat;
var cs_date_separator;

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

registerView("configuration/mail/preferences",
	function () { 
		showNode("config_mail"); 
		$("config_mail").style.display="block";
	},
	function() {
		register("OX_SAVE_OBJECT",cm_saveConfiguration);
		register("OX_Cancel_Object",cm_cancelConfiguration);
		cm_enter();
        changeTab('contentMailConfigCommon', 'tabMailConfigCommon');
        $("tabMailConfigCommon").className="tabPanelFirstHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";        
	},
	function() { 
		//configuration_askforSave();	
		unregister("OX_SAVE_OBJECT",cm_saveConfiguration);
		unregister("OX_Cancel_Object",cm_cancelConfiguration);
		cm_leave(); 
	},
	function () { 
		hideNode("config_mail"); 
		$("config_mail").style.display="none";
		$("tabMailConfigCommon").className="tabPanelFirst tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";		 
	},
	function () { 
		cm_enter(); 
	}
);

function cm_saveConfiguration() {
	if (configuration_changed_fields["gui"]) {
		configSetKey("gui.mail.view", cm_default_level1.getKey());
		configSetKey("gui.mail.view_spam", cm_default_level2.getKey());
		configSetKey("gui.mail.notifyacknoledge",getBoolofInt(getValueofRadioBox("cm_notifyacknoledge")));		
		configSetKey("gui.mail.formatmessage",getStringofRadioBox("cm_formatmessage"));
		configSetKey("gui.mail.autocomplete",getBoolofInt(getValueofRadioBox("cm_autocomplete")));		
		configSetKey("gui.mail.auto_save_drafts", cm_auto_save_mail_drafts.getKey());
		configSetKey("gui.mail.defaul_mail_font", cm_default_mail_font.getKey());
		configSetKey("gui.mail.defaul_mail_font_size", cm_default_mail_font_size.getKey());
		configSetKey("gui.effects.hover.mail",getBoolofInt(getValueofRadioBox("cm_enablehovermail")));
		configSetKey("gui.mail.select_first_message",getBoolofInt(getValueofRadioBox("cm_emailSelectFirstMessage")));
	}
	if (configuration_changed_fields["mail"]) {
		configSetKey("mail.vcard",getBoolofInt(getValueofRadioBox("cm_appendvcard")));		
		configSetKey("mail.deletemail",getBoolofInt(getValueofRadioBox("cm_deletemail")));
		configSetKey("mail.appendmailtext",getBoolofInt(getValueofRadioBox("cm_appendmailtext")));
		configSetKey("mail.inlineattachments",getBoolofInt(getValueofRadioBox("cm_inlineattachments")));
		configSetKey("mail.colorquoted",getBoolofInt(getValueofRadioBox("cm_colorquoted")));
		configSetKey("mail.emoticons",getBoolofInt(getValueofRadioBox("cm_emoticons")));
		configSetKey("mail.forwardmessage",getStringofRadioBox("cm_forwardmessage"));
		configSetKey("mail.linewrap",$("cm_linewrap").value);
		configSetKey("mail.sendaddress", cm_default_sendaddress.getKey());	
	}
	if (configuration_changed_fields["modules"]) {
		configSetKey("modules.mail.allowhtmlimages", getBoolofInt(getValueofRadioBox("cm_preloadimages")));
		if (configContainsKey("modules.mail.contactCollectEnabled") && configContainsKey("modules.mail.contactCollectFolder")) {			
			configSetKey("modules.mail.contactCollectOnMailTransport", getBoolofInt(getValueofRadioBox("cm_contactCollectOnMailTransport")));
			configSetKey("modules.mail.contactCollectOnMailAccess", getBoolofInt(getValueofRadioBox("cm_contactCollectOnMailAccess")));
		}
		configSetKey("modules.mail.replyallcc", getBoolofInt(getValueofRadioBox("cm_replyallcc")));
	}
	
	triggerEvent("OX_Save_Configuration",false,false);
}

function cm_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	configuration_changed_fields["mail"]=false;
	configuration_changed_fields["modules"]=false;
	cm_enter();	
}

var cm_default_level1, cm_default_level2;
var cm_default_sendaddress, cm_auto_save_mail_drafts, cm_default_mail_font, cm_default_mail_font_size;
var cm_init_bool=false;

register("OX_Configuration_Loaded",cm_onconfigload);
function cm_onconfigload() {
	addDefaultView("mail/list/unthreaded","List view");/*i18n*/
	addDefaultView("mail/hsplit/unthreaded","H-split view");/*i18n*/
	addDefaultView("mail/vsplit/unthreaded","V-split view");/*i18n*/
}

function cm_leave() { }

function cm_enter() {
	if(!cm_init_bool) {
		cm_init();
		cm_init_bool=true;
	}
	if(configContainsKey("gui.mail.view")) {
		cm_default_level1.setKey(configGetKey("gui.mail.view"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.mail.view_spam")) {
		cm_default_level2.setKey(configGetKey("gui.mail.view_spam"));
		configuration_changed_fields["gui"]=false;
	}	
	if(configContainsKey("gui.mail.select_first_message")) {
        setValueofRadioBox("cm_emailSelectFirstMessage",configGetKey("gui.mail.select_first_message"));
        configuration_changed_fields["gui"]=false;
    }
	if(configContainsKey("mail.deletemail")) {
		setValueofRadioBox("cm_deletemail",configGetKey("mail.deletemail"));
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("gui.mail.notifyacknoledge")) {
		setValueofRadioBox("cm_notifyacknoledge",configGetKey("gui.mail.notifyacknoledge"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("mail.appendmailtext")) {
		setValueofRadioBox("cm_appendmailtext",configGetKey("mail.appendmailtext"));
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("mail.inlineattachments")) {
		setValueofRadioBox("cm_inlineattachments",configGetKey("mail.inlineattachments"));
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("mail.vcard")) {
		setValueofRadioBox("cm_appendvcard",configGetKey("mail.vcard"));
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("gui.mail.autocomplete")) {
		setValueofRadioBox("cm_autocomplete",configGetKey("gui.mail.autocomplete"));
		configuration_changed_fields["gui"]=false;
	}	
	if(configContainsKey("mail.colorquoted")) {
		setValueofRadioBox("cm_colorquoted",configGetKey("mail.colorquoted"));
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("mail.emoticons")) {
		setValueofRadioBox("cm_emoticons",configGetKey("mail.emoticons"));
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("gui.mail.formatmessage")) {
		setStringofRadioBox("cm_formatmessage",configGetKey("gui.mail.formatmessage"));
		configuration_changed_fields["gui"]=false;
	}
	

	if(configContainsKey("gui.mail.defaul_mail_font")) {
		cm_default_mail_font.setKey(configGetKey("gui.mail.defaul_mail_font"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.mail.defaul_mail_font_size")) {
		cm_default_mail_font_size.setKey(configGetKey("gui.mail.defaul_mail_font_size"));
		configuration_changed_fields["gui"]=false;
	}
	
	if(configContainsKey("gui.mail.auto_save_drafts")) {
		cm_auto_save_mail_drafts.setKey(configGetKey("gui.mail.auto_save_drafts"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("mail.forwardmessage")) {
		setStringofRadioBox("cm_forwardmessage",configGetKey("mail.forwardmessage"));
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("mail.linewrap")) {
		$("cm_linewrap").value=configGetKey("mail.linewrap");
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("mail.sendaddress")) {
		cm_default_sendaddress.setKey(configGetKey("mail.sendaddress"));
		configuration_changed_fields["mail"]=false;
	}	
	if(configContainsKey("gui.effects.hover.mail")) {
		setIntofRadioBox("cm_enablehovermail",configGetKey("gui.effects.hover.mail"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("modules.mail.allowhtmlimages")) {
		setIntofRadioBox("cm_preloadimages",configGetKey("modules.mail.allowhtmlimages"));
		configuration_changed_fields["modules"]=false;
	}
	var emailCollectEnabled = false;
	if (configGetKey("modules.mail.contactCollectEnabled") && 
			configGetKey("modules.mail.contactCollectEnabled") == true &&
			configContainsKey("modules.mail.contactCollectFolder") &&
			configGetKey("modules.mail.contactCollectFolder") != 0) {
        setIntofRadioBox("cm_contactCollectOnMailTransport", configGetKey("modules.mail.contactCollectOnMailTransport"));
        setIntofRadioBox("cm_contactCollectOnMailAccess", configGetKey("modules.mail.contactCollectOnMailAccess"));
        configuration_changed_fields["modules"]=false;        
        oMainFolderTree.cache.get_folder(configGetKey("modules.mail.contactCollectFolder"), function(folder) { 
            $("cm_emailCollection_text").firstChild.nodeValue = format(_("Automatically collect contacts in the folder \"%s\""), [folder.oxfolder.data.title]);
        });
        emailCollectEnabled=true;        
    }
	$("cm_emailCollectionContent0").style.display=emailCollectEnabled ? "" : "none";
	$("cm_emailCollectionContent1").style.display=emailCollectEnabled ? "" : "none";
	$("cm_emailCollectionContent2").style.display=emailCollectEnabled ? "" : "none";

    if(configContainsKey("modules.mail.replyallcc")) {
        setIntofRadioBox("cm_replyallcc",configGetKey("modules.mail.replyallcc"));
        configuration_changed_fields["gui"]=false;
    }
	$("cm_header").firstChild.nodeValue=getconfigPathSelected().substring(1);	
	
	// register tabs
	setTabLists(new Array('contentMailConfigCommon','contentMailConfigCompose','contentMailConfigDisplay'),
		new Array('tabMailConfigCommon','tabMailConfigCompose','tabMailConfigDisplay'), null);	
}

function cm_init() {
	cm_default_level1= new ComboBox3(window, "cm_default_level1", "20em", 0, true,"OX_Configuration_Settings_Changed_GUI", 3);
	var mailviews=getDefaultSubviews("mail");
	for (var i in mailviews) {
		cm_default_level1.addElement(mailviews[i],i);
	}
	cm_default_level1.getDomNode();
	
	cm_default_level2= new ComboBox3(window, "cm_default_level2", "20em", 0, true,"OX_Configuration_Settings_Changed_GUI", 3);
	for (var i in mailviews) {
		cm_default_level2.addElement(mailviews[i],i);
	}
	cm_default_level2.getDomNode();	
	$("cm_default_level2_parent").style.display = configGetKey("mail.folder.spam") ? "" : "none";
	
	cm_default_sendaddress= new ComboBox3(window, "cm_default_sendaddress", "30em", 0, true,"OX_Configuration_Settings_Changed_Mail", 3);
	var aliases = configContainsKey("mail.addresses") ? configGetKey("mail.addresses") : new Array();
	for (a=0; a < aliases.length; a++) {
		cm_default_sendaddress.addElement(aliases[a],aliases[a]);
	}
	cm_default_sendaddress.getDomNode();
	
	// pre-fill with default parameter if not set in config
	if (!configContainsKey("gui.mail.auto_save_drafts"))
		configSetKey("gui.mail.auto_save_drafts",5);
	
	var myarray=[60000,180000,300000,600000,900000,1800000];
	cm_auto_save_mail_drafts = new ComboBox3(window, "cm_auto_save_mail_drafts", "15em", 0, true,"OX_Configuration_Settings_Changed_GUI", 3);
	cm_auto_save_mail_drafts.addElement(_("Disabled"),0); /*i18n*/
	var m = function(n) { return function() { return getInterval(n); }; }; 
	for(var i=0;i<myarray.length;i++) {
		if(!myarray[i]== 0) {
			cm_auto_save_mail_drafts.addElement("",(myarray[i]/60000),m((myarray[i])));
		}
	}
	cm_auto_save_mail_drafts.getDomNode();
	
	cm_default_mail_font = new ComboBox3(window, "cm_default_mail_font", "15em", 0, true,"OX_Configuration_Settings_Changed_GUI", 5);
	cm_default_mail_font.addElement(_("Default"),'default');
	cm_default_mail_font.addElement("Andale Mono",'andale mono,times'); 
	cm_default_mail_font.addElement("Arial",'arial,helvetica,sans-serif'); 
	cm_default_mail_font.addElement("Arial Black","arial black,avant garde");
	cm_default_mail_font.addElement("Book Antiqua","book antiqua,palatino");
	cm_default_mail_font.addElement("Comic Sans MS","comic sans ms,sans-serif");
	cm_default_mail_font.addElement("Courier New","courier new,courier");
	cm_default_mail_font.addElement("Georgia","georgia,palatino");
	cm_default_mail_font.addElement("Helvetica","helvetica");
	cm_default_mail_font.addElement("Impact","impact,chicago");
	cm_default_mail_font.addElement("Symbol","symbol");
	cm_default_mail_font.addElement("Tahoma","tahoma,arial,helvetica,sans-serif");
	cm_default_mail_font.addElement("Terminal","terminal,monaco");
	cm_default_mail_font.addElement("Times New Roman","times new roman,times");
	cm_default_mail_font.addElement("Trebuchet MS","trebuchet ms,geneva");
	cm_default_mail_font.addElement("Verdana","verdana,geneva");
	cm_default_mail_font.addElement("Webdings","webdings");
	cm_default_mail_font.addElement("Wingdings","wingdings,zapf dingbats");					
	cm_default_mail_font.getDomNode();
	
	cm_default_mail_font_size = new ComboBox3(window, "cm_default_mail_font_size", "6em", 0, true,"OX_Configuration_Settings_Changed_GUI", 3);
	cm_default_mail_font_size.addElement(_("Default"),'default');
	cm_default_mail_font_size.addElement("1 (8pt)",1); 
	cm_default_mail_font_size.addElement("2 (10pt)",2);
	cm_default_mail_font_size.addElement("3 (12pt)",3); 
	cm_default_mail_font_size.addElement("4 (14pt)",4);
	cm_default_mail_font_size.addElement("5 (18pt)",5);
	cm_default_mail_font_size.addElement("6 (24pt)",6);
	cm_default_mail_font_size.addElement("7 (36pt)",7);  	
	cm_default_mail_font_size.getDomNode();
	
}

function cm_linewrap_changed() {
	var newvalue=trimStr($("cm_linewrap").value);
	if (newvalue == "")
		newvalue=0;
	newvalue=parseInt(newvalue, 10);
	if(isNaN(newvalue) || newvalue < 0) {
		newvalue=configGetKey("mail.linewrap");
	}
	$("cm_linewrap").value=newvalue;
	configuration_changed_fields["mail"]=true;
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * 
 */

// global var which holds a common storage with all accounts
// needed later for folder subscribe and updates
var mail_accounts;

register("OX_Configuration_Loaded", function () {	
	mail_accounts = new Storage(0, [], 0, 0, 0, 0, function(data) { return data.id; });
		
	function loadAccounts(cb) {
		ox.JSON.get(AjaxRoot + "/account?action=all&session=" + session,
	        	// data handler
	            function(reply) {
	                mail_accounts.remove(0, mail_accounts.ids.length);
	                var nData = [];
	                for (var i in reply.data) {
	                	nData.push(mapArray2Object(reply.data[i]));
	                }
	                mail_accounts.append(nData);
	                if (cb) cb();
	            },
	            // error handler
	            function(error) {
	            	if (cb) cb(error);
	            	return false; // standard error handler will be called 
	            });
	}
	// load 
	
	if (configGetKey("modules.mail.module") != null) {
		loadAccounts(null);
	}

	// if not enabled we won't continue
	if (configGetKey("modules.mail.module") == null || !configGetKey("modules.mailaccount.module")) return;
		
	var node = new ox.Configuration.LeafNode("configuration/mail/accounts", 
			newnode("span",0,0,[ 
			                    newnode("span",0,0,[document.createTextNode(_("Accounts"))]), 
			                    newnode("span",{background:"orange",marginLeft:"5px",padding:"2px",
			                    	MozBorderRadius:"2px",WebkitBorderRadius:"2px",color:"white"},0,
			                    		[ addTranslated("New")]) 
			                  ]));
	var split = new ox.Configuration.VSplit(node, _("E-Mail Accounts"), 0.28, true);
	
	/*
     * mapping array from server to object
     */
    function mapArray2Object(data) {    	
    	var mObj = {};
    	mObj.id = data[0];
    	mObj.login = data[1];
    	mObj.password = null; //data[2];
    	mObj.mail_url = data[3];
    	mObj.transport_url = data[4];
    	mObj.name = data[5];
    	mObj.primary_address = data[6];
    	mObj.spam_handler = data[7];
    	//mObj.trash = data[8];
    	//mObj.sent = data[9];
    	//mObj.drafts = data[10];
    	//mObj.spam = data[11];
    	//mObj.confirmed_spam = data[12];
    	//mObj.confirmed_ham = data[13];
    	mObj.mail_server = data[14];
    	mObj.mail_port = data[15];
    	mObj.mail_protocol = data[16];
    	mObj.mail_secure = data[17];
    	mObj.transport_server = data[18];
    	mObj.transport_port = data[19];
    	mObj.transport_protocol = data[20];
    	mObj.transport_secure = data[21];
    	mObj.transport_login = data[22];
    	mObj.transport_passord = data[23];
    	mObj.unified_inbox_enabled = data[24];
    	mObj.trash_fullname = data[25];
    	mObj.sent_fullname = data[26];
    	mObj.drafts_fullname = data[27];
    	mObj.spam_fullname = data[28];
    	mObj.pop3_refresh_rate = data[31];
    	mObj.pop3_expunge_on_quit = !data[32];
    	mObj.pop3_delete_write_through = data[33];
    	mObj.personal = data[36];
    	return mObj;
    }
    
    // Helper
    function addCheckBox(accountId) {
        var checkbox = newnode("input", 0, { type: "checkbox" });
        addDOMEvent(checkbox, "click", (function() {
            return function() {
                if (typeof(accountId) != "undefined") {
                    // talk with server
                    var data = { "id": accountId, "unified_inbox_enabled": !!checkbox.checked };
                    ox.JSON.put(AjaxRoot + "/account?action=update&session=" +
                        session, data, function(reply) {
                            // notify
                            // ox.Configuration.info(_("Your settings have been saved."));
                            // updating folder tree
                            oMainFolderTree.cache.update(null, true, null);
                            // update right checkbox (only)
                            try {
                                d = split.get();
                                d.unified_inbox_enabled = reply.data.unified_inbox_enabled;
                                split.set(d);
                                // stop asking if nothing was changes
                                split.original.unified_inbox_enabled = d.unified_inbox_enabled;
                                // thx to preuss' "brilliant" idea
                                mail_accounts.data.data[accountId].unified_inbox_enabled = d.unified_inbox_enabled;
                            } catch(e) { }
                    });
                }
            }
        })());
        return checkbox;
    }

	/** Init function **/
	split.init = function() {
	    var selection = new Selection();
	    var grid = new LiveGrid([
	        // Acount name
	        { 
	            text: _("Account name"),
	            clear: LiveGrid.makeClear(""),
	            set: function(div, data) {
	                if (div.firstChild)
	                    div.firstChild.data = data.name || "";
	                else
	                    div.appendChild(document.createTextNode(data.name || ""));
	            }
	        },
	        // Unified INBOX flag
	        {
	            text: _("Use Unified INBOX")/* i18n */,
	            width: "12em",
	            clear: emptyFunction,
	            set: function(div, data) {
	                if (!div.firstChild) {
	                    div.appendChild(addCheckBox(data.id));
	                }
	                div.firstChild.checked = data.unified_inbox_enabled || false;
	            }
	        }
	    ], selection);
	    grid.emptylivegridtext = _("No accounts available");
	    
	    split.list = grid;
	    
	    split.enableList = function() {
	    	loadAccounts(
	    			function() {
		            	grid.enable(mail_accounts);
	    			}
	    	);
	    };
	    
	    split.save = function(data, cont) {
	    	var nData = clone(data);
	    	
	    	// remove some fields if required
	    	if (!trimStr(nData.password).length) {
	    		delete(nData.password);
	    	}
	    	if (!nData.transport_credentials) {
	    		delete(nData.transport_login);
	    		delete(nData.transport_password);
	    	}
	    	delete(nData.transport_credentials);
	    	
	    	nData.pop3_expunge_on_quit = !nData.pop3_expunge_on_quit;
	    	nData.mail_port = parseInt(nData.mail_port);
	    	nData.transport_port = parseInt(nData.transport_port);
	    	nData.transport_protocol = "smtp";
	    	if (nData["mail_protocol"] == "pop3") {
	    		nData.pop3_storage = "mailaccount";
	    	}
	    	
	    	if ("id" in data) {
	    		for (var i in nData) {
	        		if (nData[i] == undefined || nData[i] == "undefined") nData[i]=null; //delete(nData[i]);
	        	}
	            ox.JSON.put(AjaxRoot + "/account?action=update&session=" +
	                        session, nData, function(reply) {
	            				mail_accounts.localUpdate([data.id], function(old) {
	                                if (!equals(data, old)) return data;
	                            });
	                            ox.Configuration.info(
	                                _("Your settings have been saved."));
	                            // updating folder tree
	            	            oMainFolderTree.cache.update(null, true, null);
	            	            reply.data.pop3_expunge_on_quit=!reply.data.pop3_expunge_on_quit;
	            	            cont(reply.data);
	                        });
	        } else {
	        	nData.spam_handler = "NoSpamHandler";
	            ox.JSON.put(AjaxRoot + "/account?action=new&session=" +
	                        session, nData, handleNew);
	        }
	    	
	    	function handleNew(reply) {
	    		if (!reply || !reply.data) {
	    			triggerEvent("OX_New_Error", 4, format(_("Syntax error in server reply:\n%s"), "no error provided"));
	    			return;
	    		}	    		
	    		var data = reply.data;
	    		data.pop3_expunge_on_quit=!data.pop3_expunge_on_quit;
	    		mail_accounts.append([data]);
	            ox.Configuration.info(_("Your settings have been saved."));	            
	            //globalalert.SHOWAGAIN=true;	    		
	            newAlert(_("Info"), _("You have set up an external E-Mail account. The sole responsibility for the availability of the external E-Mail account lies with the service provider."),
	            		function() {
		            		globalalert.SHOWAGAIN=null;
		            		cont(data);
		            		split.onNew();
	            		}
	            );

	            // updating folder tree
	            oMainFolderTree.cache.update(null, true, null);
	        }
	    }
	    
	    split.load = function(cont) {
	    	split.right.scrollTop = 0;
	    	mail_accounts.newIterate(selection.getSelected(), emptyFunction,
	            function(i, data) {
	                if (data.errormsg) return cont();
	                var d = clone(data);
	                cont(d);
	            });
	    };
	    
	    split.onNew = function() {
	    	split.right.scrollTop = 0;
	    	this.addNew({ name: _("New account") });
	    };
	    
	    
	    /*** menu items ***/
	    menuarrows[node.id] = {};
	    
	    var rulesmenu = MenuNodes.createSmallButtonContext("mail.accounts",
	        _("Rules"));
	    MenuNodes.createSmallButton(rulesmenu, "mail.accounts.delete",
	        _("Delete"), getFullImgSrc("img/menu/delete.gif"),
	        getFullImgSrc("img/menu/delete_d.gif"), confirmDelete);
	    function confirmDelete() {
	        if (!selection.count) return;
	        newConfirm(ngettext("Delete Account", "Delete Accounts", selection.count),
	            ngettext("Are you sure you want to delete the selected account?",
	                     "Are you sure you want to delete the selected accounts?",
	                     selection.count),
	            AlertPopup.YES | AlertPopup.NO, null, null, handleYes);
	    }
	    function handleYes() {
	    	mail_accounts.newIterate(selection.getSelected(), emptyFunction, handleDelete);
	    }
	    function handleDelete(idx, data) {
	        ox.JSON.put(AjaxRoot + "/account?action=delete&session=" + session,
	            [ data.id ], handleReply);
	        function handleReply(reply) {
	            grid.deleteIDs([data.id]);
	            // updating folder tree
	            oMainFolderTree.cache.update(null, true, null);
	        }
	    }
	    addMenuNode(rulesmenu.node, MenuNodes.FIXED, 31);
	    changeDisplay(node.id, "mail.accounts");
	    
	    register("OX_SELECTED_ITEMS_CHANGED", function() {
	        var deleteenabled = selection.count >= 1;
	        if (grid.storage) {
	            grid.storage.newIterate(selection.getSelected(), emptyFunction, emptyFunction, updateMenu);
	        } else updateMenu();	        
	        function updateMenu() {
	            menuglobalzaehler = 0;
	            menuarrows[node.id]["mail.accounts"] = [];
	            menu_display_contents(node.id, "mail.accounts", deleteenabled,
	                "mail.accounts.delete");
	        }
	    });
	    
	    /*** new/edit fields on the right side ***/
	    
	    /*** blank line ***/
	    var lb = function() { ox.UI.Widget.call(this); };
	    lb.prototype = extend(ox.UI.Widget, {
	        addContent: function() {
	           this.node = this.parent.addRow(newnode("br", null, false));
            }
	    });
        
        function disabler(widget) {
            return {
                get: ox.Configuration.Group.NoField.get,
                set: function(data) {
                    widget.setEnabled(data.id !== 0);
                    return data;
                }
            };
        }
        
        /*** ACCOUNT SETTINGS ***/
	    var account = new ox.Configuration.Group(_("Account Settings"));
	    var name = new ox.UI.Input(_("Account Name"));
	    account.addWidget(name, "name");
	    var primary_address = new ox.UI.Input(_("E-Mail Address"));
	    account.addWidget(primary_address, "primary_address");
	    var personal = new ox.UI.Input(_("Your name"));
	    account.addWidget(personal, "personal");
	    var unifiedCheckbox = new ox.UI.CheckBox(_("Use Unified INBOX for this account"));
	    account.addWidget(unifiedCheckbox, "unified_inbox_enabled");
	    account.addWidget(new lb());
        split.addWidget(account, {
            get: ox.Configuration.Group.NoField.get,
            set: function(data) {
                name.setEnabled(data.id !== 0);
                primary_address.setEnabled(data.id !== 0);
                return data;
            }
        });
	    
	    /*** SERVER SETTINGS ***/
	    var mail = new ox.Configuration.Group(_("Server Settings")); 
        split.addWidget(mail, disabler(mail));
	    
	    function changePort() {
	    	switch(mail_protocol.get()) {
	        	case "imap": 
	        		if (mail_secure.get()) {
	    	    		mail_port.set("993");
	    	    	} else {
	    	    		mail_port.set("143");	    	
	    	    	}
	        		mail_pop_note.setVisible(false);
	        		pop_refresh_rate.setVisible(false);
	        		pop_expunge_on_quit.setVisible(false);
	        		pop_delete_write_through.setVisible(false);
	        		break;
	        	case "pop3":
	        		if (mail_secure.get()) {
	    	    		mail_port.set("995");
	    	    	} else {
	    	    		mail_port.set("110");	    	
	    	    	}
	        		mail_pop_note.setVisible(true);
	        		pop_refresh_rate.setVisible(true);
	        		pop_expunge_on_quit.setVisible(true);
	        		pop_delete_write_through.setVisible(true);
	        		break;
	    	}
	    }

	    
	    var mail_protocol = new ox.UI.ComboBox(_("Server Type"));
	    mail_protocol.width = "18.5em";
	    mail_protocol.setEntries(["imap","pop3"], [_("IMAP Mail Server"),_("POP3 Mail Server")]); 
	    mail_protocol.changed = changePort;
	    mail_protocol.default_value = "imap";
	    mail.addWidget(mail_protocol, "mail_protocol");
	    
	    var mail_pop_note = new ox.UI.Text(_("Please note: All messages received from the POP3 account will be stored to a folder on your local IMAP account."));
	    mail_pop_note.disable();
	    mail_pop_note.setVisible(false);
	    mail.addWidget(mail_pop_note, ox.Configuration.Group.NoField);
	    
	    var mail_secure = new ox.UI.CheckBox(_("Use SSL connection"));
	    mail.addWidget(mail_secure, "mail_secure");
	    mail_secure.changed = changePort;
	    
	    var mail_server = new ox.UI.Input(_("Server Name")); 
	    mail.addWidget(mail_server, "mail_server");
	    var mail_port = new ox.UI.Input(_("Server Port"));
	    mail_port.default_value = "143";
	    mail.addWidget(mail_port, "mail_port");
	    
	    var login = new ox.UI.Input(_("Login"));
	    mail.addWidget(login, "login");
	    var password = new ox.UI.Password(_("Password"));
	    mail.addWidget(password, "password");
	    
	    var pop_refresh_rate = new ox.UI.ComboBox(_("Check for new messages every 'n' minutes"));
	    pop_refresh_rate.width = "5em";	    
	    pop_refresh_rate.setEntries(["3","5","10","15","30","60","360"], ["3","5","10","15","30","60","360"]);
	    pop_refresh_rate.setVisible(false);
	    mail.addWidget(pop_refresh_rate, "pop3_refresh_rate"); 
	    
	    var pop_expunge_on_quit = new ox.UI.CheckBox(_("Leave messages on server"));
	    pop_expunge_on_quit.setVisible(false);
	    pop_expunge_on_quit.changed = function() {
	    	if (pop_expunge_on_quit.get() == false) {
	    		pop_delete_write_through.set(false);
	    	}
	    	pop_delete_write_through.setEnabled(pop_expunge_on_quit.get());	    	
	    }
	    mail.addWidget(pop_expunge_on_quit, "pop3_expunge_on_quit");
	    
	    var pop_delete_write_through = new ox.UI.CheckBox(_("Deleting messages on local storage also deletes them on server"));
	    pop_delete_write_through.setEnabled(false);
	    mail.addWidget(pop_delete_write_through, "pop3_delete_write_through");
	    
	    mail.addWidget(new lb());
	    
	    /*** TRANSPORT SETTINGS ***/
	    var transport = new ox.Configuration.Group(_("Outgoing Server Settings (SMTP)"));
	    split.addWidget(transport, disabler(transport));
	    
	    var transport_secure = new ox.UI.CheckBox("Use SSL connection");
	    transport.addWidget(transport_secure, "transport_secure");
	    transport_secure.changed = function() {
	    	if (transport_secure.get()) transport_port.set("465");
	    	else transport_port.set("25");
	    };
	    
	    transport.addWidget(new ox.UI.Input(_("Server Name")), "transport_server");
	    
	    var transport_port  = new ox.UI.Input(_("Server Port"));
	    transport_port.default_value = "25";
	    transport.addWidget(transport_port, "transport_port");
	    
	    var transport_credentials = new ox.UI.CheckBox(_("Use username and password"));
	    transport.addWidget(transport_credentials, "transport_credentials");
	    transport_credentials.changed = function(bool) {
	    	var bool = transport_credentials.get();
	    	transport_login.setEnabled(bool);
	    	transport_password.setEnabled(bool);
	    };
	    
	    var transport_login = new ox.UI.Input(_("Login"));	    
		transport.addWidget(transport_login, "transport_login");		
		transport_login.disable();
		
		var transport_password = new ox.UI.Password(_("Password"));
		transport.addWidget(transport_password, "transport_password");
		transport_password.disable();
		
	    split.addWidget(new lb());
	    
	    /*** FOLDER SETTINGS ***/	    
	    var folder = new ox.Configuration.Group(_("Folder Settings"));
	    split.addWidget(folder, {
            get: ox.Configuration.Group.NoField.get,
            set: function(data) {
                folder.setVisible(Boolean(data.id));
                return data;
            }
        });
	    	    
	    var sent_fullname = new temporary.MailFolderSelection(_("Sent folder"));        
	    sent_fullname.width = "30em";
	    folder.addWidget(sent_fullname, "sent_fullname");
        
        var trash_fullname = new temporary.MailFolderSelection(_("Trash folder"));        
        trash_fullname.width = sent_fullname.width;
        folder.addWidget(trash_fullname, "trash_fullname");
        
        var drafts_fullname = new temporary.MailFolderSelection(_("Drafts folder"));        
        drafts_fullname.width = sent_fullname.width;
        folder.addWidget(drafts_fullname, "drafts_fullname");
        
        var spam_fullname = new temporary.MailFolderSelection(_("Spam folder"));        
        spam_fullname.width = sent_fullname.width;
        folder.addWidget(spam_fullname, "spam_fullname");
	    
        folder.addWidget(new lb());
        
        /*** BUTTONS ***/
	        
	    var buttons = new ox.Configuration.HLayout();
	    
	    var check_button = new ox.UI.Button(_("Check connection"));
	    check_button.click = function() { 
	    	newAlert(_("Info"), _("Please wait while checking the connection ... This may take a while ..."));
	    	$(globalalert.visibleButtons[0].id).style.display="none";
	    	var data = clone(split.get());
	    	if (selection.getSelected().length == 1) {
	    		data.id = selection.getSelected()[0];
	    		delete(data.password);
	    	}
	    	data.tree = false;
	    	ox.JSON.put(AjaxRoot + "/account?action=validate&session=" + session, data, 
	    			function(reply) {	    				
        				newAlert(_("Info"), reply.data ? _("The connection was successful.") : _("Connection failed! Please check your settings."));
                    },
                    function(reply) {
                    	newAlert(_("Error"), _("Connection failed! Please check your settings: ") + formatError(reply));
                    	return true;
                    });
	    };
        buttons.addWidget(check_button);
        split.addWidget(buttons, {
            get: emptyFunction,
            set: function(data) { check_button.setEnabled(data.id !== 0); }
        });
	    
	    var save_button = new ox.UI.Button(_("Save"));
	    save_button.click = function(data, pata) {
	    	function fail(field) {
	    		setTimeout(function() { 
	    			triggerEvent("OX_New_Error", 4, format(_("The mandatory field %1$s is not defined."), field)); 
	    		}, 0);
	    		return;
	    	}
	    	if (name.get() == "") {
	    		name.formnode.focus();
	    		return fail(_("Account Name"));
	    	} else if (primary_address.get() == "") {	  
	    		primary_address.formnode.focus();
	    		return fail(_("E-Mail Address"));	 
	    	} else if (mail_server.get() == "") {
	    		mail_server.formnode.focus();
	    		return fail(_("Server Name"));
    		} else if (login.get() == "") {
	    		login.formnode.focus();
	    		return fail(_("Login"));
    		} else if (!split["id"] && password.isEnabled && password.get() == "") {
    			password.formnode.focus();
	    		return fail(_("Password"));
    		}
	    	split.saveView(); 	    	
	    };
	    buttons.addWidget(save_button);
	
	    var cancel_button = new ox.UI.Button(_("Cancel"));
	    cancel_button.click = function() { split.cancelView(); };
	    buttons.addWidget(cancel_button);
	    
	    //split.disable();
	}
});
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var cms_init_bool=false;
var cms_currentsignature=-1;
var cms_signatures=new Array();
var cms_signatureposition;

function ConfigSignatures() {
	this.cbok;
	this.cbcancel;
	this.grid;
	this.storage;
	this.selection = new Selection();
    this.storage = new Storage(0, [], 0, 0, 0, 0, function(data) { return data.id; });    
}
ConfigSignatures.initGrid = function() {
	configsignatures.grid = new LiveGrid([
    { 
        text: "Name",
        i18n: true,
        clear: LiveGrid.makeClear(""),
        set: function(div, data) {
            if (div.firstChild)
                div.firstChild.data = data.name;
            else
                div.appendChild(document.createTextNode(data.name));
        }
    },
    {
        text: "Place",
        i18n: true,
        clear: LiveGrid.makeClear(""),
        width: "6em",
        set: function(div, data) {
        	var place = data.place.match(/below/) ? _("below") : _("above");
            if (div.firstChild)
                div.firstChild.data = place;
            else
                div.appendChild(document.createTextNode(place));
        }
    },
    {
        text: "Default",
        i18n: true,
        clear: LiveGrid.makeClear(""),
        width: "6em",
        set: function(div, data) {
            if (div.firstChild)
                div.firstChild.data = data.isDefault ? _("Yes") : "";
            else
                div.appendChild(document.createTextNode(data.isDefault ? _("Yes") : ""));
        }
    }
    ], configsignatures.selection);
    configsignatures.grid.emptylivegridtext = "";
    configsignatures.grid.events.register("Selected", function() {
    	// get selected signature
    	var ids = configsignatures.grid.selection.getSelected();
    	// clear current preview
    	removeChildNodes($("cms_signatures_preview"));
    	if (ids.length != 0) {
    		// replace newlines by BR tags (IE7 needs the space for subsequent BR tags!)
    		var signature_text = cms_signatures[ids[0]].signature_text.replace(/\n/g, " <br/>");
    		// cleanup spaces
    		signature_text = replaceLeadingSpaces(signature_text);
    		// set content
    		$("cms_signatures_preview").innerHTML = signature_text;
    		// parse links in preview
    	   	parseDirectLinksInMails($("cms_signatures_preview"));
    	}
    	// fire global event
    	triggerEvent("SubSelected", ids.length);
    	
    	function replaceLeadingSpaces(text) {
    		return text.replace(/(^|<br\s*\/?>)([ \t]+)|([ \t]{2,}|\t)/g,
    			function(_, prefix, m1, m2) {
    				var match = (m1 || m2).replace(/\t/g, "        "); // TODO: real tabs
    				var retval = new Array((match.length + 3) >> 1);
    				retval[0] = prefix || "";
    				var max = match.length >> 1;
    				for (var i = 1; i <= max; i++) retval[i] = "&nbsp; ";
    				if (match.length & 1) retval[retval.length - 1] = "&nbsp;";
    				return retval.join("");
    			});
    	}
    });
    configsignatures.grid.events.register("Activated", function(ids) {           
            if (ids && ids.length > 0) {
                triggerEvent("OX_Configuration_Edit_Signature");
            }
        }
    );
    configsignatures.grid.events.register("Delete", 
        function(ids){
            deleteMails(activefolder, ids) 
        }
    );
    
    // add livegrid header and content to dom node
    $("cms_signatures_header").appendChild(configsignatures.grid.getHeader());
    configsignatures.grid.getTable($("cms_signatures_grid"));
}
ConfigSignatures.open = function () {
	showNode("disable_background_window");
	$("disable_background_window").style.display="block";
	showNode("config_popups_win");
	$("config_popups_win").style.display="block";
	showNode("window_signature");
	centerPopupWindow($("window_signature"));
	$("window_signature").style.display="block";
}
ConfigSignatures.close = function () {
	if (this.closecb) { globalalert.cbclose(); }
	hideNode("window_signature");
	$("window_signature").style.display="none";
	hideNode("config_popups_win");
	$("config_popups_win").style.display="none";
	hideNode("disable_background_window");
	var childs=	$("disable_background_window").childNodes;
	var closeall=true;
	for(var i=0;i<childs.length;i++) {
		if(childs[i].tagName && childs[i].tagName == "DIV") {
			if(childs[i].style.display && childs[i].style.display!= "none" ) {
				closeall=false;
			}
		}
	}
	if(closeall) {
		$("disable_background_window").style.display="none";
	}
	if (configsignatures.grid && configsignatures.grid.focus != undefined) {
		setFocus($("cms_signatures_grid"));
		configsignatures.grid.selection.click(configsignatures.grid.focus);
		configsignatures.grid.showFocus();
	}
}
ConfigSignatures.commitcancel = function () {
	if(configsignatures.cbcancel) { 
		if(configsignatures.cbcancel()) {
			ConfigSignatures.close();
		}
	} else { 
		ConfigSignatures.close(); 
	}
}
ConfigSignatures.commitok = function () {
	if(configsignatures.cbok) { 
		if(configsignatures.cbok()) {
			ConfigSignatures.close();
		}
	} else { 
		ConfigSignatures.close(); 
	}
}

register("Loaded", function () {
	addOnClose($("window_signature"), 
	   function() {
	   	   ConfigSignatures.close() 
	   }
	); 
});

var configsignatures=new ConfigSignatures();

function openSignatureWindow(sig_name,sig_place,sig_signature,sig_default,cbok,cbcancel) {
	$("signature_window_signature_name").value=sig_name;
	setFocus($("signature_window_signature_name"));	
	cms_signatureposition.setKey(sig_place);
	$("cms_signaturetext").value=sig_signature;
	$("signature_default").checked=sig_default;
	configsignatures.cbok=cbok;
	configsignatures.cbcancel=cbcancel;
	ConfigSignatures.open();
} 

registerView("configuration/mail/signatures",
	function () { 
		showNode("config_mail_signatures"); 
		$("config_mail_signatures").style.display="block"; },
	function() { 
		register("OX_Configuration_Add_Signature",cms_addSignature);
		register("OX_Configuration_Edit_Signature",cms_editSignature);
		register("OX_Configuration_Remove_Signature",cms_removeSignature);
 		register("OX_SAVE_OBJECT",cms_saveConfiguration);
		register("OX_Cancel_Object",cms_cancelConfiguration);
		cms_enter();
		if (!configsignatures.grid) {
			ConfigSignatures.initGrid();
		}
		configsignatures.grid.enable(configsignatures.storage);
	},
	function() {
		//configuration_askforSave();
		unregister("OX_Configuration_Add_Signature",cms_addSignature);
		unregister("OX_Configuration_Edit_Signature",cms_editSignature);
		unregister("OX_Configuration_Remove_Signature",cms_removeSignature);
 		unregister("OX_SAVE_OBJECT",cms_saveConfiguration);
		unregister("OX_Cancel_Object",cms_cancelConfiguration);
		configsignatures.grid.disable();
		cms_leave();
	},
	function () { 
		hideNode("config_mail_signatures"); 
		$("config_mail_signatures").style.display="none"; 
	},
	null
);

function checkDuplicateSignatures(myname) {
	for(var i=0;i<cms_signatures.length;i++) {
		if(cms_signatures[i].signature_name==myname) return true;
	}
	return false;
}
function cms_enter() {
	if(!cms_init_bool) {
		cms_init();
		cms_init_bool=true;
	}
	cms_signatures=new Array();
	if (configContainsKey("gui.mail.signatures")) {
		cms_signatures=configGetKey("gui.mail.signatures");
		configuration_changed_fields["gui"]=false;
	}
	
	cms_fillSignature();	
	$("cms_header").firstChild.nodeValue=getconfigPathSelected().substring(1);
}
function cms_init() {
	cms_signatureposition= new ComboBox3(window, "cms_signatureposition", "95%", 1, true,"OX_Configuration_Mail_Signatures_Position_Changed", null);
	var key="below";
	var key2="above"
	cms_signatureposition.addElement("Above the text",key2);/*i18n*/
	cms_signatureposition.addElement("Below the text",key);/*i18n*/
	cms_signatureposition.getDomNode();
}
function cms_fillSignature() {
	configsignatures.storage.remove(0, configsignatures.storage.ids.length);
	for (var i=0; i<cms_signatures.length; i++) {
        var sig_name = cms_signatures[i].signature_name.length == 0 ? _("Unnamed signature")  : cms_signatures[i].signature_name;       
        configsignatures.storage.append([{ id: i, name: sig_name, place: cms_signatures[i].position, isDefault: cms_signatures[i].signature_default }]);     
    }
	triggerEvent("SubSelected",0);	
}
function cms_editSignature() {	
	cms_currentsignature = configsignatures.grid.selection.getSelected()[0];	
	openSignatureWindow(cms_signatures[cms_currentsignature].signature_name,cms_signatures[cms_currentsignature].position,cms_signatures[cms_currentsignature].signature_text,cms_signatures[cms_currentsignature].signature_default,cms_changeSignature);
}
function cms_changeSignature() {
	var myobject=new Object();
	if (trimStr($("signature_window_signature_name").value).length == 0) {
        newAlert(_("Invalid Signature"),_("Please enter a name")); /*i18n*/
        $("signature_window_signature_name").focus();
        return false;
    } else if (checkDuplicateSignatures(trimStr($("signature_window_signature_name").value))) {
		if(cms_signatures[cms_currentsignature].signature_name != trimStr($("signature_window_signature_name").value)) {
			newAlert(_("Invalid Signature"),_("This Signature name already exists")); /*i18n*/
			$("signature_window_signature_name").focus();
			return false;		
		}
	}
	myobject.signature_name=trimStr($("signature_window_signature_name").value);
	myobject.position=cms_signatureposition.getKey();
	myobject.signature_text=$("cms_signaturetext").value;
	myobject.signature_default=$("signature_default").checked;
	if(myobject.signature_default) {
		for(var i=0;i<cms_signatures.length;i++) {
			cms_signatures[i].signature_default=false;
		}	
	}
	cms_signatures[cms_currentsignature]=myobject;
	configuration_changed_fields["gui"]=true;
	cms_fillSignature();
	return true;
	
}
function cms_addSignature() {	
	var zaehler=0;
	var sig_name=_("New Signature");
	if (checkDuplicateSignatures(sig_name)) { zaehler=2; }
	while (checkDuplicateSignatures(sig_name+" ("+zaehler+")")) {
		zaehler ++;
	}
	if(zaehler!=0) {
		sig_name=sig_name+" ("+zaehler+")";
	}
	var sig_place="below";
	var sig_signature="";
	var sig_default=false;
	openSignatureWindow(sig_name,sig_place,sig_signature,sig_default,cms_newSignature);
	configuration_changed_fields["gui"]=true;
}
function cms_newSignature() {	
	var myobject=new Object();
	if (trimStr($("signature_window_signature_name").value).length == 0) {
        newAlert(_("Invalid Signature"),_("Please enter a name")); /*i18n*/
        $("signature_window_signature_name").focus();
        return false;
    } else if (!checkDuplicateSignatures(trimStr($("signature_window_signature_name").value))) {
		myobject.signature_name=trimStr($("signature_window_signature_name").value);
		myobject.position=cms_signatureposition.getKey();
		myobject.signature_text=$("cms_signaturetext").value;
		myobject.signature_default=$("signature_default").checked;
		if(myobject.signature_default) {
			for(var i=0;i<cms_signatures.length;i++) {
				cms_signatures[i].signature_default=false;
			}	
		}
	} else {
		newAlert(_("Invalid Signature"),_("This Signature name already exists"));
		$("signature_window_signature_name").focus();
		return false;
	}
	cms_signatures.push(myobject);
	configuration_changed_fields["gui"]=true;
	cms_fillSignature();
	return true;
}
function cms_removeSignature() {
	for (var i=0; i<configsignatures.grid.selection.getSelected().length; i++) {
	   cms_signatures.splice(configsignatures.grid.selection.getSelected()[i], 1);
	}
	cms_fillSignature();
	configuration_changed_fields["gui"]=true;
}
function cms_saveConfiguration() {
	if(configuration_changed_fields["gui"]) {
		configSetKey("gui.mail.signatures",cms_signatures);
	}
	triggerEvent("OX_Save_Configuration",false,false);
}
function cms_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	cms_enter();	
}
function cms_leave() { }
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

registerView("configuration/calendar/preferences",
	function () { 
		showNode("config_calendar"); 
		$("config_calendar").style.display="block";
    },
	function () { 
		register("OX_SAVE_OBJECT",cc_saveConfiguration);
		register("OX_Cancel_Object",cc_cancelConfiguration);
		cc_enter(); 
		},
	function () { 
		//configuration_askforSave();
		unregister("OX_SAVE_OBJECT",cc_saveConfiguration);
		unregister("OX_Cancel_Object",cc_cancelConfiguration);
		cc_leave(); 
		},
	function () { 
		hideNode("config_calendar"); 
		$("config_calendar").style.display="none";
    },
	function () { cc_enter(); }
);

function cc_saveConfiguration() {
	if(configuration_changed_fields["gui"]) {
		configSetKey("gui.calendar.interval",cc_interval.getKey());
		
		configSetKey("gui.calendar.default_reminder",cc_default_reminder.getKey());
		
		configSetKey("gui.calendar.starttime",cc_work_start.getKey());
		configSetKey("gui.calendar.endtime",cc_work_end.getKey());
		configSetKey("gui.calendar.view",cc_default_level1.getKey());
		configSetKey("gui.global.confirmpopup",getBoolofInt(getValueofRadioBox("cs_confirmpopup")));
		
		configSetKey("gui.calendar.day.numberofappointments",cc_countappointmentday.getKey());
		configSetKey("gui.calendar.workweek.numberofappointments",cc_countappointmentww.getKey());
		configSetKey("gui.calendar.workweek.startday",cc_startdayofworkweek.getKey());
		configSetKey("gui.calendar.workweek.countdays",cc_daysinworkweek.getKey());
		configSetKey("gui.calendar.custom.countdays",cc_daysincustom.getKey());
		configSetKey("gui.calendar.custom.numberofappointments",cc_countappointmentcustom.getKey());

		configSetKey("gui.calendar.autoadd_participant_public",getBoolofInt(getValueofRadioBox("cs_calendar_add_participant_public")));	

		configSetKey("gui.effects.hover.calendar",getBoolofInt(getValueofRadioBox("cc_enablehovercalendar")));	
		menulastviews["calendar"]=cc_default_level1.getKey();
	}
	if (configuration_changed_fields["modules"]) {
		configSetKey("modules.calendar.defaultStatusPrivate",cc_defaultstatusprivate.getKey());
		configSetKey("modules.calendar.defaultStatusPublic",cc_defaultstatuspublic.getKey());
	}

	/*
     * store notification settings to config, if changed 
     */
    if (configuration_changed_fields["calendarnotification"]) {
        configSetKey("modules.calendar.notifyNewModifiedDeleted",getBoolofInt(getValueofRadioBox("cs_calendarnotification_0")));   
        configSetKey("modules.calendar.notifyAcceptedDeclinedAsCreator",getBoolofInt(getValueofRadioBox("cs_calendarnotification_1")));
        configSetKey("modules.calendar.notifyAcceptedDeclinedAsParticipant",getBoolofInt(getValueofRadioBox("cs_calendarnotification_2")));
    }
	
	triggerEvent("OX_Save_Configuration",false,false);
}
function cc_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	cc_enter();
}
var cc_init_bool=false;
var cc_interval;
var cc_default_reminder;
var cc_work_start;
var cc_work_end;
var cc_default_level1;
var cc_countappointmentww,cc_countappointmentday,cc_countappointmentcustom,cc_daysinworkweek,cc_daysincustom,cc_startdayofworkweek,cc_defaultstatusprivate,cc_defaultstatuspublic;

function cc_enter() {
	if(!cc_init_bool) {
		cc_init();
		cc_init_bool=true;
	}
	if(configContainsKey("gui.calendar.interval")) {
		cc_interval.setKey(configGetKey("gui.calendar.interval"));
		configuration_changed_fields["gui"]=false;
	}
	
	if(configContainsKey("gui.calendar.default_reminder")) {
		cc_default_reminder.setKey(configGetKey("gui.calendar.default_reminder"));
		configuration_changed_fields["gui"]=false;
	}
	
	if(configContainsKey("gui.calendar.starttime")) {
		cc_work_start.setKey(configGetKey("gui.calendar.starttime"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.endtime")) {
		cc_work_end.setKey(configGetKey("gui.calendar.endtime"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.view")) {
		cc_default_level1.setKey(configGetKey("gui.calendar.view"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.global.confirmpopup")) {
		setValueofRadioBox("cs_confirmpopup",configGetKey("gui.global.confirmpopup"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.interval")) {
		cc_interval.setKey(configGetKey("gui.calendar.interval"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.day.numberofappointments")) {
		cc_countappointmentday.setKey(configGetKey("gui.calendar.day.numberofappointments"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.workweek.numberofappointments")) {
		cc_countappointmentww.setKey(configGetKey("gui.calendar.workweek.numberofappointments"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.workweek.startday")) {
		cc_startdayofworkweek.setKey(configGetKey("gui.calendar.workweek.startday"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.workweek.countdays")) {
		cc_daysinworkweek.setKey(configGetKey("gui.calendar.workweek.countdays"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.custom.countdays")) {
		cc_daysincustom.setKey(configGetKey("gui.calendar.custom.countdays"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.custom.numberofappointments")) {
		cc_countappointmentcustom.setKey(configGetKey("gui.calendar.custom.numberofappointments"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("modules.calendar.defaultStatusPrivate")) {
		cc_defaultstatusprivate.setKey(configGetKey("modules.calendar.defaultStatusPrivate"));
		configuration_changed_fields["modules"]=false;
	}
	if(configContainsKey("modules.calendar.defaultStatusPublic")) {
		cc_defaultstatuspublic.setKey(configGetKey("modules.calendar.defaultStatusPublic"));
		configuration_changed_fields["modules"]=false;
	}

	if(configContainsKey("gui.effects.hover.calendar")) {
		setIntofRadioBox("cc_enablehovercalendar",configGetKey("gui.effects.hover.calendar"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.autoadd_participant_public")) {
		setIntofRadioBox("cs_calendar_add_participant_public",configGetKey("gui.calendar.autoadd_participant_public"));
		configuration_changed_fields["gui"]=false;
	}
	if (configContainsKey("modules.calendar.notifyNewModifiedDeleted")) {
        setValueofRadioBox("cs_calendarnotification_0",configGetKey("modules.calendar.notifyNewModifiedDeleted"));
        configuration_changed_fields["calendarnotification"]=false;
    }
    if (configContainsKey("modules.calendar.notifyAcceptedDeclinedAsCreator")) {
        setValueofRadioBox("cs_calendarnotification_1",configGetKey("modules.calendar.notifyAcceptedDeclinedAsCreator"));
        configuration_changed_fields["calendarnotification"]=false;
    }
    if (configContainsKey("modules.calendar.notifyAcceptedDeclinedAsParticipant")) {
        setValueofRadioBox("cs_calendarnotification_2",configGetKey("modules.calendar.notifyAcceptedDeclinedAsParticipant"));
        configuration_changed_fields["calendarnotification"]=false;
    }
	$("cc_header").firstChild.nodeValue=getconfigPathSelected().substring(1);	
}

register("OX_Configuration_Loaded",cc_onconfigload);
function cc_onconfigload() {
	addDefaultView("calendar/calendar/day","Calendar day view");/*i18n*/
	addDefaultView("calendar/calendar/workweek","Calendar workweek view");/*i18n*/
	addDefaultView("calendar/calendar/month","Calendar month view");/*i18n*/
	addDefaultView("calendar/calendar/week","Calendar week view");/*i18n*/
	addDefaultView("calendar/calendar/custom","Calendar custom view");/*i18n*/
	if(configGetKey("modules.calendar.calendar_freebusy") && configGetKey("modules.calendar.calendar_teamview")) {
		addDefaultView("calendar/team/day","Team day view");/*i18n*/
		addDefaultView("calendar/team/workweek","Team workweek view");/*i18n*/
	}
	addDefaultView("calendar/list/day","List day view");/*i18n*/
	addDefaultView("calendar/list/workweek","List workweek view");/*i18n*/
	addDefaultView("calendar/list/month","List month view");/*i18n*/
	addDefaultView("calendar/list/week","List week view");/*i18n*/
}

 
function cc_init() {
	function config_translateTime(value) {
		return function() { return formatDate(value,"time"); };
	}
	cc_interval= new ComboBox3(window, "cc_interval", "11em", 1, true,"OX_Configuration_GUI_Changed", null);
	cc_interval.addElement("5",5);
	cc_interval.addElement("10",10);
	cc_interval.addElement("15",15);
	cc_interval.addElement("20",20);
	cc_interval.addElement("30",30);
	cc_interval.addElement("60",60);
	cc_interval.getDomNode();	
	
	var timearray=["00:00","01:00","02:00","03:00","04:00","05:00","06:00","07:00","08:00","09:00","10:00","11:00","12:00","13:00","14:00","15:00","16:00","17:00","18:00","19:00","20:00","21:00","22:00","23:00"];
	
	function makeInterval(t) { return function() { return getInterval(t); }; }
	var h = 60, d = 1440, w = 10080; // minutes per hour, day and week
    var cc_reminder_intervals = [0, 15, 30, 45, 1*h, 2*h, 4*h, 6*h, 8*h, 12*h,1*d, 2*d, 3*d, 4*d, 5*d, 6*d, 1*w, 2*w, 3*w, 4*w];
	cc_default_reminder = new ComboBox3(window, "cc_reminder_status", "11em", 2, true, "OX_Configuration_GUI_Changed", 5);
	cc_default_reminder.addElement("no reminder"/*i18n*/,"-1");
    for (var i = 0; i < cc_reminder_intervals.length; i++) {
        cc_default_reminder.addElement("", cc_reminder_intervals[i], makeInterval(cc_reminder_intervals[i] * 6e4)); // ms / min
    }
    cc_default_reminder.getDomNode();
	
	
	cc_work_start= new ComboBox3(window, "cc_work_start", "11em", 1, true,"OX_Configuration_GUI_Changed", 5);
	for(var i=0;i<timearray.length;i++) {
		cc_work_start.addElement(timearray[i],i,config_translateTime(new Date(Date.UTC(2000,1,1,i,0,0))));
	}
	cc_work_start.getDomNode();	
	cc_work_end= new ComboBox3(window, "cc_work_end", "11em", 1, true,"OX_Configuration_GUI_Changed", 5);
	for(var i=0;i<timearray.length;i++) {
		cc_work_end.addElement(timearray[i],i,config_translateTime(new Date(Date.UTC(2000,1,1,i,0,0))));
	}
	cc_work_end.getDomNode();	
	
	cc_default_level1= new ComboBox3(window, "cc_default_level1", "22em", 1, true,"OX_Configuration_GUI_Changed", 5);
	var calviews=getDefaultSubviews("calendar");
	for (var i in calviews) {
		cc_default_level1.addElement(calviews[i],i);
	}
	cc_default_level1.getDomNode();
	cc_countappointmentww= new ComboBox3(window, "cc_countappointmentww", "11em", 1, true,"OX_Configuration_GUI_Changed", 5);
	cc_countappointmentday= new ComboBox3(window, "cc_countappointmentday", "11em",1, true,"OX_Configuration_GUI_Changed", 5);
	cc_countappointmentcustom= new ComboBox3(window, "cc_countappointmentcustom", "11em",1, true,"OX_Configuration_GUI_Changed", 5);
	cc_daysinworkweek= new ComboBox3(window, "cc_daysinworkweek", "11em",1, true,"OX_Configuration_GUI_Changed", 5);
	cc_daysincustom= new ComboBox3(window, "cc_daysincustom", "11em",1, true,"OX_Configuration_GUI_Changed", 5);
	cc_startdayofworkweek= new ComboBox3(window, "cc_startdayofworkweek", "11em",1, true,"OX_Configuration_GUI_Changed", 5);
	for (var i2=1;i2<=8;i2++) {
		cc_countappointmentcustom.addElement(i2,i2);
		cc_countappointmentww.addElement(i2,i2);
		cc_countappointmentday.addElement(i2,i2);
	}
	for (var i2=1;i2<=7;i2++) {
		cc_daysinworkweek.addElement(i2,i2);
		cc_daysincustom.addElement(i2,i2);
		
	}
	for (var i2=0;i2<weekdays.length;i2++) {
		cc_startdayofworkweek.addElement(weekdays[i2],i2);
	}
	
	cc_defaultstatusprivate= new ComboBox3(window, "cc_defaultstatusprivate", "11em",1, true,"OX_Configuration_Settings_Changed_Modules", 3);
	cc_defaultstatuspublic= new ComboBox3(window, "cc_defaultstatuspublic", "11em",1, true,"OX_Configuration_Settings_Changed_Modules", 3);
	
	cc_defaultstatusprivate.addElement("waiting",0);
	cc_defaultstatusprivate.addElement("accepted",1);
	cc_defaultstatusprivate.addElement("tentative",3);

	cc_defaultstatuspublic.addElement("waiting",0);
	cc_defaultstatuspublic.addElement("accepted",1);
	cc_defaultstatuspublic.addElement("tentative",3);

	
	cc_countappointmentday.getDomNode();
	cc_daysinworkweek.getDomNode();
	cc_startdayofworkweek.getDomNode();
	cc_countappointmentww.getDomNode();
	cc_daysincustom.getDomNode();
	cc_countappointmentcustom.getDomNode();
	cc_defaultstatusprivate.getDomNode();
	cc_defaultstatuspublic.getDomNode();	
}
function cc_leave() {
	
}

fileloaded();
var oCi_import_data = null;
var importDataFolderTree = null;
var importFolderId = -1;

register("Loaded", function () {
	addOnClose($("window_import_status"), function() { oCi_import_data.closeWindow(); }); 
});

registerView("configuration/import",
	function () { 
		showNode("config_import"); 
		$("config_import").style.display="block";
	},
	function() { 		
		oCi_import_data = new Ci_import_data();
		oCi_import_data.createCombobox();
		if(!config.modules.calendar.module || !config.modules.tasks.module) {
			$("cs_import_ical").disabled = "disabled";
			$('cs_import_vcard').checked = true;
		} else {
			$('cs_import_ical').checked = true;
			if (importFolderDestination != null && importFolderDestination.oxfolder.data.module == "contacts"){
				$('cs_import_vcard').checked = true;
				oCi_import_data.combobox.disable();
				oCi_import_data.action="VCARD";
			} else if (importFolderDestination != null && importFolderDestination.oxfolder.data.module == "tasks"){
				oCi_import_data.combobox.setKey("tasks");
			}
		}
		oCi_import_data.form = $('form_config_import');
		oCi_import_data.form.file.value="";
		register("OX_SAVE_OBJECT",uploadImportData);
	},
	function() {
		unregister("OX_SAVE_OBJECT",uploadImportData);
		unregister("cb_importComboChanged",cb_importComboChanged);
		unregister('cb_importComboCSVChanged', cb_importComboCSVChanged);
	},
	function () { 
		hideNode("config_import"); 
		$("config_import").style.display="none"; 
		oCi_import_data.closeWindow();
	},
	function () { }
);

function uploadImportData() {
	if(!oCi_import_data.process)
		oCi_import_data.uploadData();
}

function Ci_import_data() {
	this.action = "ICAL";
	this.folder = configGetKey("folder.calendar");
	this.combobox = null;
	this.process = false;
	$("fileImportInput").disabled = false;
	$("cimp_header").firstChild.nodeValue=getconfigPathSelected().substring(1);	
}

function cb_importComboChanged() {
	if(oCi_import_data.action == "ICAL")
		oCi_import_data.changeStatus("ical");	
}

function cb_importComboCSVChanged() {
	if(oCi_import_data.action == "CSV" || oCi_import_data.action == "OUTLOOK_CSV")
		oCi_import_data.changeStatus("csv");	
}

Ci_import_data.prototype = {
	uploadData : function() {	
		this.form = $('form_config_import');
		this.uri = AjaxRoot + "/import?action="+this.action+"&session="+session+"&folder="+importFolderId //this.folder;	
		this.form.action = this.uri; 
		this.form.target="dlIframe"
		if(this.form.file.value=="") {
			triggerEvent("OX_New_Error", 4, _("Please select a file to import"));
		}
		else {
			this.process = true;
			this.form.submit();
			$("fileImportInput").disabled = true;
		}
	}, 
	createCombobox : function() {
		var cbText = new Array();
		cbText[0] = "Appointments"; /*i18n*/
		cbText[1] = "Tasks"; /*i18n*/
		cbText[2] = "Comma Separated"; /*i18n*/
		cbText[3] = "Outlook file"; /*i18n*/
		this.combobox = new ComboBox3(window, "import.combobox.module", "20em", 
			0, true, "cb_importComboChanged", null);
		this.combobox.addElement(cbText[0],"calendar");
		this.combobox.addElement(cbText[1],"tasks");
		this.combobox.getDomNode();
		if(!config.modules.calendar.module || !config.modules.tasks.module)
			this.combobox.disable();
		register('cb_importComboChanged', cb_importComboChanged);
		this.comboboxCSV = new ComboBox3(window, "import.combobox.csv", "20em", 
			0, true, "cb_importComboCSVChanged", null);
		this.comboboxCSV.addElement(cbText[2],"CSV");
		this.comboboxCSV.addElement(cbText[3],"OUTLOOK_CSV");
		this.comboboxCSV.getDomNode();
		this.comboboxCSV.disable();
		register('cb_importComboCSVChanged', cb_importComboCSVChanged);
		
		if (importFolderDestination != null) {
			setFolder(importFolderDestination.oxfolder.data.id);
		} else {
			setFolder(configGetKey("folder.calendar") || configGetKey("folder.contacts"));
		}
	},
	
	openWindow: function() {
		showNode("disable_background_window");
		$("disable_background_window").style.display="block";
		showNode("config_popups_win");
		$("config_popups_win").style.display="block";
		showNode("window_import_status");
		centerPopupWindow($("window_import_status"));
		$("window_import_status").style.display="block";
	}, 
	
	closeWindow: function() {
		hideNode("window_import_status");
		$("window_import_status").style.display="none";
		hideNode("config_popups_win");
		$("config_popups_win").style.display="none";
		hideNode("disable_background_window");
		var childs=	$("disable_background_window").childNodes;
		var closeall=true;
		for(var i=0;i<childs.length;i++) {
			if(childs[i].tagName && childs[i].tagName == "DIV") {
				if(childs[i].style.display && childs[i].style.display!= "none" ) {
					closeall=false;
				}
			}
		}
		if(closeall) {
			$("disable_background_window").style.display="none";
		}
		$("cms_import_status").firstChild.data = "";
		$("cms_import_log").value = "";
		this.form.reset();
	},
	
	changeStatus : function(suffix) {
		var Self = this;
		switch(suffix) {
			case 'ical'		 	: 	Self.action = "ICAL";
									
									Self.combobox.enable();
									Self.comboboxCSV.disable();
													
									Self.folder  = configGetKey("folder."+Self.combobox.getKey());
									
									if (importFolderDestination == null || importFolderDestination.oxfolder.data.module == "contacts")
										setFolder(Self.folder);
									else
										setFolder(importFolderDestination.oxfolder.data.id);
									
									break;
				
			case 'vcard' 		: 	Self.action = "VCARD";
									Self.folder = configGetKey("folder.contacts");
									
									Self.combobox.disable();
									Self.comboboxCSV.disable();

									if (importFolderDestination == null || importFolderDestination.oxfolder.data.module != "contacts")
										setFolder(Self.folder);
									else
										setFolder(importFolderDestination.oxfolder.data.id);
									
									break;
			
			case 'csv' 			: Self.action = Self.comboboxCSV.getKey();
									Self.folder = configGetKey("folder.contacts");
									Self.comboboxCSV.enable();
									Self.combobox.disable();

									if (importFolderDestination == null || importFolderDestination.oxfolder.data.module != "contacts")
										setFolder(Self.folder);
									else
										setFolder(importFolderDestination.oxfolder.data.id);
									
									break;
		}
	}
}

function import_getWarningsAsString(warnings) {
    var retVal = [];
    for (var i = 0; i < warnings.length; i++) {
        retVal.push(escapeHTML(formatError(warnings[i], "%2$s (%1$s, %3$s)")) + "\n");
    }
    return retVal.join();
}

function callback_import(arg) {
	var textM = "";
	oCi_import_data.process = false;
	$("fileImportInput").disabled = false;
	
	if (arg.error) {
		newServerError(arg);
	} else if (arg.data && arg.data.length != 0) {
		var successfullImported = 0;
		var importLog = "";
		
		for (var i=0; i<arg.data.length; i++) {
			if (arg.data[i].error) {				
				importLog += escapeHTML(formatError(arg.data[i], "%2$s (%1$s, %3$s)")) + "\n";
				if (arg.data[i].warnings && arg.data[i].warnings.length) {
					importLog += import_getWarningsAsString(arg.data[i].warnings);
				}
				if (arg.data[i].category && arg.data[i].category == 13){
				    successfullImported++;
				}
			} else if (arg.data[i].warnings && arg.data[i].warnings.length) {
                importLog += import_getWarningsAsString(arg.data[i].warnings);
            } else {
				successfullImported++;
			}
		}
		
		$("cms_import_log").value = importLog.length != 0 ? importLog : _("None");
		// #. %d is the number of successfully imported data records
		textM = format(_("Successfully imported: %d"), successfullImported);		
		oCi_import_data.openWindow();
	} else {
		oCi_import_data.closeWindow();
		triggerEvent("OX_New_Error", 4, _("Internal Error: The server didn't provide any data."));
	}
	$("cms_import_status").firstChild.data = textM;
}

function toggleConfigTree(){
	if (document.getElementsByName('cs_import_type')[0].checked == true){
		clickedItem = configGetKey("folder.calendar");
	} else {
		clickedItem = configGetKey("folder.contacts");
	}
	
	initImportTree();
	
	if ($("TreeDialogImportForlder").style.display == "none"){
		$("TreeDialogImportForlder").style.display = "block";
		$("TreeDialogImportForlder").style.top = "230px";
		$("TreeDialogImportForlder").style.left = "420px";
	}else{
		$("TreeDialogImportForlder").style.display = "none";
	}
		
}

function initImportTree() {		
		
	importDataFolderTree = null;
	removeChildNodes($("folder_tree_info"));
	importDataFolderTree = new cFolderTree(	$('folder_tree_info'),
										folderConfigAction,										
										false,
										oMainFolderTree.cache,
										optFolderState.getState('folder_tree_info'));
	if (document.getElementsByName('cs_import_type')[0].checked == true){
		if (oCi_import_data.combobox.getKey() == "calendar"){
			importDataFolderTree.enabled_modules = {calendar:true};
		} else {
			importDataFolderTree.enabled_modules = {tasks:true};
		}
	} else {
		importDataFolderTree.enabled_modules = {contacts:true};
	}
	importDataFolderTree.setSaveConfiguration(optFolderState);	
	importDataFolderTree.load();
}


function cb_getpath(sPath) {
	document.getElementsByName('importFolderInput')[0].value = sPath;
	
}

function setFolder(fId){
	importFolderId = fId;
	oMainFolderTree.get_folder_path(fId, cb_getpath);
}

function folderConfigAction(ofolder) {
	importFolderDestination = ofolder;
	var OXFolder = ofolder.oxfolder;
	toggleConfigTree();
	clickedItem = OXFolder.data.id;
	setFolder(clickedItem);
}

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

function ConfigTeams() {
	this.teams=new Array();
	this.cbok;
	this.cbcancel;
}
ConfigTeams.open = function () {
	showNode("disable_background_window");
	$("disable_background_window").style.display="block";
	showNode("config_popups_win");
	$("config_popups_win").style.display="block";
	showNode("window_teams");
	centerPopupWindow($("window_teams"));
	$("window_teams").style.display="block";
}
ConfigTeams.close = function () {
	if(this.closecb) { globalalert.cbclose(); }
	hideNode("window_teams");
	$("window_teams").style.display="none";
	hideNode("config_popups_win");
	$("config_popups_win").style.display="none";
	var childs=	$("disable_background_window").childNodes;
	var closeall=true;
	for(var i=0;i<childs.length;i++) {
		if(childs[i].tagName && childs[i].tagName == "DIV") {
			if(childs[i].style.display && childs[i].style.display != "none") {
				closeall=false;
			}
		}
	}
	if(closeall) {
		hideNode("disable_background_window");
		$("disable_background_window").style.display="none";
	}
}
ConfigTeams.commitcancel = function () {
	if(configteams.cbcancel) { 
		if(configteams.cbcancel()) {
			ConfigTeams.close();
		}
	}
	else { ConfigTeams.close(); }
}
ConfigTeams.addMember = function() {
	cct_addPermanentMembers();
}
ConfigTeams.removeMember = function () {
	cct_removePermanentMembers();
}
ConfigTeams.commitok = function () {
	if(configteams.cbok) { 
		if(configteams.cbok()) {
			ConfigTeams.close();
		} 
	}
	else { ConfigTeams.close(); }
}
register("Loaded", function () {
	addOnClose($("window_teams"),function() { ConfigTeams.close() }); 
	}
);
var configteams=new ConfigTeams();

function openTeamsWindow(team_name,team_members,team_default,cbok,cbcancel) {
	if(team_members) {
		configteams.teams=clone(team_members);
	} else {
		configteams.teams=new Array();
	}
	$("team_window_team_name").value=team_name;
	$("team_default").checked=team_default;
	configteams.cbok=cbok;
	configteams.cbcancel=cbcancel;
	ConfigTeams.open();
	cct_fillMembers();
	if(configteams.teams.length>0) {
		cct_selectMember(document.getElementById("Member-"+configteams.teams[0].id));
		
	}
	
} 
var cct_beforeenter=false;
registerView("configuration/calendar/teams",
	function () {
		showNode("config_calendar_team"); 
		if(cct_participant_window == null)
			cct_createParticipants_PopUp();
		$("config_calendar_team").style.display="block"; },
	function () { 
				  register("OX_Configuration_Teams_Add_Team",cct_addnewTeam);
				  register("OX_Configuration_Teams_Edit_Team",cct_editTeam);
				  register("OX_Configuration_Teams_Remove_Team",cct_removenewTeam);
				  register("OX_SAVE_OBJECT",cct_saveConfiguration);
				  register("OX_Cancel_Object",cct_cancelConfiguration);
				  cct_enter();	
				},
	function()  { 
				 //configuration_askforSave();
 				 cct_leave();
				 unregister("OX_Configuration_Teams_Add_Team",cct_addnewTeam);
 				 unregister("OX_Configuration_Teams_Edit_Team",cct_editTeam);
	    	     unregister("OX_Configuration_Teams_Remove_Team",cct_removenewTeam);
	    	     unregister("OX_SAVE_OBJECT",cct_saveConfiguration);
				 unregister("OX_Cancel_Object",cct_cancelConfiguration);
				 
				},
	function () { 
		hideNode("config_calendar_team"); 
		$("config_calendar_team").style.display="none"; },
	function () { cct_enter(); }
);

function cct_saveConfiguration() {
	configSetKey("gui.calendar.teams",cct_tempteams);
	triggerEvent("OX_Save_Configuration",false,false);
}
function cct_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	cct_enter();	
}
function checkDuplicateTeams(myname) {
	for(var i=0;i<cct_tempteams.length;i++) {
		if(cct_tempteams[i].name==myname) return true;
	}
	return false;
}

var cct_currentteam=-1;
var cct_currentmember=-1;
var cct_tempteams=new Array();
var cct_participant_window = null;
function cct_enter() {
	cct_beforeenter=configuration_changed_fields["gui"];
	cct_tempteams=new Array();
	if(configContainsKey("gui.calendar.teams")) {
		cct_tempteams=configGetKey("gui.calendar.teams");
	}	
	cct_fillTeams();
	if(cct_tempteams.length>0) {
		cct_selectTeam(document.getElementById("Team-0"));
	}
	$("cct_header").firstChild.nodeValue=getconfigPathSelected().substring(1);		
}
function cct_addnewTeam() {
	var zaehler=0;
	var myobject=new Object();
	teamname=_("New Team");
	if(checkDuplicateTeams(teamname)) { zaehler=2; }
	while(checkDuplicateTeams(teamname+"("+zaehler+")")) {
		zaehler ++;
	}
	if(zaehler!=0) {
		teamname=teamname+"("+zaehler+")";
	}
	openTeamsWindow(teamname,new Array(),false,cct_createTeam);
	configuration_changed_fields["gui"]=true;
}
function cct_editTeam() {
	openTeamsWindow(cct_tempteams[cct_currentteam].name,cct_tempteams[cct_currentteam].children,cct_tempteams[cct_currentteam].team_default,cct_changeTeam);	
	configuration_changed_fields["gui"]=true;
}
function cct_createTeam() {
	var myobject=new Object();
	if(!checkDuplicateTeams($("team_window_team_name").value)) {
		myobject.name=$("team_window_team_name").value;
		myobject.team_default=$("team_default").checked;
		if(myobject.team_default) {
			for(var i=0;i<cct_tempteams.length;i++) {
				cct_tempteams[i].team_default=false;
			}	
		}
		myobject.children=clone(configteams.teams);
	} else {
		newAlert(_("Invalid Team"),_("This Team name already exists"));
		return false;
	}
	cct_tempteams.push(myobject);
	configuration_changed_fields["gui"]=true;
	cct_fillTeams();
	cct_selectTeam(document.getElementById("Team-"+(cct_tempteams.length-1)));
	return true;
}
function cct_changeTeam() {
	var myobject=new Object();
	if(checkDuplicateTeams($("team_window_team_name").value)) {
		if($("team_window_team_name").value != cct_tempteams[cct_currentteam].name) {
			newAlert(_("Invalid Team"),_("This Team name already exists"));
			return false;		
		}
	}
	myobject.name=$("team_window_team_name").value;
	myobject.team_default=$("team_default").checked;
	if(myobject.team_default) {
		for(var i=0;i<cct_tempteams.length;i++) {
			cct_tempteams[i].team_default=false;
		}	
	}
	myobject.children=clone(configteams.teams);
	cct_tempteams[cct_currentteam] = myobject;
	configuration_changed_fields["gui"]=true;
	cct_fillTeams();
	cct_selectTeam(document.getElementById("Team-"+(cct_tempteams.length-1)));
	return true;
}

function cct_fillTeams() {
	removeChildNodes($("cct_teams"));
	for(var i=0;i<cct_tempteams.length;i++) {
		var newteam=$("ctd_template_one_row").cloneNode("false");
		var textnode=document.createTextNode(cct_tempteams[i].name);
		newteam.id="Team-"+i;
		newteam.appendChild(textnode);
		$("cct_teams").appendChild(newteam);	
	}
	triggerEvent("SubSelected",0);	
}
function cct_selectTeam(param) {
	var allteams=param.parentNode.getElementsByTagName("div");
	for (var i=0;i<allteams.length;i++) {
		allteams[i].className = "background-color-content font-color-default";
		if(cct_tempteams[i].team_default) {
			allteams[i].style.fontStyle="italic";
			allteams[i].style.fontWeight="bold";
		} 
	}
	param.className = "background-color-PMG-selection-elements font-color-default";
	cct_currentteam=param.id.split("-")[1];
//	fillMembers();
	triggerEvent("SubSelected",1);
}
function cct_fillMembers() {
	removeChildNodes($("cct_members"));
	for(var i=0;i<configteams.teams.length;i++) {
		var newmember=$("ctd_template_one_member").cloneNode("false");
		var textnode=document.createTextNode(configteams.teams[i].display_name);
		newmember.id="Member-"+configteams.teams[i].id;
		newmember.appendChild(textnode);
		$("cct_members").appendChild(newmember);	
	}
	triggerEvent("SubSelectedTeamMember",0);
}

function cct_removenewTeam() {
	cct_tempteams.splice(cct_currentteam,1);
	cct_fillTeams();
	triggerEvent("SubSelected",0);
	if(cct_tempteams.length>0) {
		cct_selectTeam(document.getElementById("Team-0"));
	}
	configuration_changed_fields["gui"]=true;
}
function cct_addPermanentMembers() {
	cct_participant_window.openAddParticipantsWindow(); 
}
function cct_removePermanentMembers() {
	for(var z=0;z<configteams.teams.length;z++) {
		if(configteams.teams[z].id==cct_currentmember) {
			configteams.teams.splice(z,1);
			break;
		}
	}
	cct_fillMembers();
	if(configteams.teams.length>0) {
		cct_selectMember(document.getElementById("Member-"+configteams.teams[0].id))		
	} else {
		cct_currentmember=-1;
	}
}
function cct_team_name_changed() {
	var cct_inputfield=$("team_name_field");
	cct_tempteams[cct_currentteam].name=cct_inputfield.value;
	document.getElementById("Team-"+cct_currentteam).firstChild.nodeValue=cct_inputfield.value;
	configuration_changed_fields["gui"]=true;
}
function cct_createParticipants_PopUp() {
	cct_participant_window = new ParticipantsSmall(null,newPermanentUsers,true,true,true,false,"Select Users", /*i18n*/
							null,null,true,true);
	function newPermanentUsers(response) {
		for(i in response) {
			var available=false;
			for(var z=0;z<configteams.teams.length;z++) {
				if(configteams.teams[z].id==response[i].id) {
					available=true;
					configteams.teams[z]==response[i];
					break;
				}
			}
			if(!available) {
				configteams.teams.push(response[i]);
			}
		}
		cct_fillMembers();
		if(configteams.teams.length>0) {
			cct_selectMember(document.getElementById("Member-"+configteams.teams[0].id))		
		} else {
			cct_currentmember=-1;
		}		
	}
}

function cct_leave() {
}
function cct_selectMember(param) {
	var allmembers=param.parentNode.getElementsByTagName("div");
	for (var i=0;i<allmembers.length;i++) {		
		allmembers[i].className = removeClass(allmembers[i].className,"background-color-PMG-selection-elements");
	}

	param.className += " background-color-PMG-selection-elements";
	cct_currentmember=param.id.split("-")[1];
	triggerEvent("SubSelectedTeamMember",1);
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

registerView("configuration/contacts/preferences",
	function () { 
		showNode("config_contact"); 
		$("config_contact").style.display="block"; },
	function() { 
		register("OX_SAVE_OBJECT",ccon_saveConfiguration);
		register("OX_Cancel_Object",ccon_cancelConfiguration);
		ccon_enter();
	},
	function() {
		//configuration_askforSave();
		unregister("OX_SAVE_OBJECT",ccon_saveConfiguration);
		unregister("OX_Cancel_Object",ccon_cancelConfiguration);
		ccon_leave();
		
	},
	function () { 
		hideNode("config_contact"); 
		$("config_contact").style.display="none"; },
	function() {
		ccon_enter();
	}
);

var ccon_init_bool=false;
var ccon_default_level1;
var ccon_rows_cardview;
register("OX_Configuration_Loaded",ccon_onconfigload);
function ccon_onconfigload() {
	addDefaultView("contacts/phonelist","Phone list");
	addDefaultView("contacts/cards","Cards");
}
function ccon_init() {
	ccon_default_level1= new ComboBox3(window, "ccon_default_level1", "16em", 1, true,"OX_Configuration_GUI_Changed", 5);
	var conviews=getDefaultSubviews("contacts");
	for (var i in conviews) {
		ccon_default_level1.addElement(conviews[i],i);
	}
	ccon_default_level1.getDomNode();
	
	ccon_rows_cardview= new ComboBox3(window, "ccon_rows_cardview", "16em", 0, true,"OX_Configuration_GUI_Changed", 5);
	ccon_rows_cardview.addElement('auto','auto'); /*i18n*/
	ccon_rows_cardview.addElement(4,4);
	ccon_rows_cardview.addElement(5,5);
	ccon_rows_cardview.addElement(6,6);
	ccon_rows_cardview.addElement(7,7);
	ccon_rows_cardview.getDomNode();
}
function ccon_enter() {
	if(!ccon_init_bool) {
		ccon_init();
		ccon_init_bool=true;
	}
	if(configContainsKey("gui.contacts.view")) {
		ccon_default_level1.setKey(configGetKey("gui.contacts.view"));
		ccon_rows_cardview.setKey(configGetKey("gui.contacts.cardsToViewPerColumn"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.contacts")) {
		setIntofRadioBox("ccon_enablehovercontacts",configGetKey("gui.effects.hover.contacts"));
		configuration_changed_fields["gui"]=false;
	}	
	$("ccon_header").firstChild.nodeValue=getconfigPathSelected().substring(1);		
}
function ccon_saveConfiguration() {
	if(configuration_changed_fields["gui"]==true) {
		configSetKey("gui.contacts.view",ccon_default_level1.getKey());
		configSetKey("gui.contacts.cardsToViewPerColumn",ccon_rows_cardview.getKey());
		configSetKey("gui.effects.hover.contacts",getBoolofInt(getValueofRadioBox("ccon_enablehovercontacts")));
		menulastviews["contacts"]=ccon_default_level1.getKey();
	}
	triggerEvent("OX_Save_Configuration",false,false);
}
function ccon_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	ccon_enter();
}
function ccon_leave() {
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

registerView("configuration/tasks/preferences",
	function () { 
		showNode("config_tasks"); 
		$("config_tasks").style.display="block"; },
	function() {
	    register("OX_SAVE_OBJECT",ct_saveConfiguration);
		register("OX_Cancel_Object",ct_cancelConfiguration);
		ct_enter();
	},
	function() {
		//configuration_askforSave();
	    unregister("OX_SAVE_OBJECT",ct_saveConfiguration);
		unregister("OX_Cancel_Object",ct_cancelConfiguration);
		ct_leave();
	},
	function () { 
		hideNode("config_tasks"); 
		$("config_tasks").style.display="none"; },
	function() { ct_enter();}
);

var ct_init_bool=false;
var ct_default_level1;
var ct_interval;
register("OX_Configuration_Loaded",ct_onconfigload);
function ct_onconfigload() {
	addDefaultView("tasks/list","List view");
	addDefaultView("tasks/split","H-split view");
}
function ct_init() {
	ct_default_level1= new ComboBox3(window, "ct_default_level1", "16em", 1, true,"OX_Configuration_GUI_Changed", 5);
	var tasviews=getDefaultSubviews("tasks");
	for (var i in tasviews) {
		ct_default_level1.addElement(tasviews[i],i);
	}
	ct_default_level1.getDomNode();
	ct_interval = new ComboBox3(window, "ct_interval", "16em", 1, true,"OX_Configuration_GUI_Changed", null);
	ct_interval.addElement("5",5);
	ct_interval.addElement("10",10);
	ct_interval.addElement("15",15);
	ct_interval.addElement("20",20);
	ct_interval.addElement("30",30);
	ct_interval.addElement("60",60);
	ct_interval.getDomNode();

}
function ct_enter() {
	if(!ct_init_bool) {
		ct_init();
		ct_init_bool=true;
	}
	if(configContainsKey("gui.tasks.view")) {
		ct_default_level1.setKey(configGetKey("gui.tasks.view"));
		configuration_changed_fields["gui"]=false;
	}	
	if(configContainsKey("gui.tasks.interval")) {
		ct_interval.setKey(configGetKey("gui.tasks.interval"));
		configuration_changed_fields["gui"]=false;
	}	
	if(configContainsKey("gui.effects.hover.tasks")) {
		setIntofRadioBox("ct_enablehovertasks",configGetKey("gui.effects.hover.tasks"));
		configuration_changed_fields["gui"]=false;
	}
    if(configContainsKey("modules.tasks.notifyNewModifiedDeleted")) {
        setValueofRadioBox("cs_tasknotification_0",configGetKey("modules.tasks.notifyNewModifiedDeleted"));
        configuration_changed_fields["tasknotification"]=false;
    }
	if(configContainsKey("modules.tasks.notifyAcceptedDeclinedAsCreator")) {
        setValueofRadioBox("cs_tasknotification_1",configGetKey("modules.tasks.notifyAcceptedDeclinedAsCreator"));
        configuration_changed_fields["tasknotification"]=false;
    }
    if(configContainsKey("modules.tasks.notifyAcceptedDeclinedAsParticipant")) {
        setValueofRadioBox("cs_tasknotification_2",configGetKey("modules.tasks.notifyAcceptedDeclinedAsParticipant"));
        configuration_changed_fields["tasknotification"]=false;
    }
	$("ct_header").firstChild.nodeValue=getconfigPathSelected().substring(1);		
		
}
function ct_saveConfiguration() {
	if(configuration_changed_fields["gui"]==true) {
		configSetKey("gui.tasks.view",ct_default_level1.getKey());
		configSetKey("gui.tasks.interval",ct_interval.getKey());
		menulastviews["tasks"]=ct_default_level1.getKey();
		configSetKey("gui.effects.hover.tasks",getBoolofInt(getValueofRadioBox("ct_enablehovertasks")));
	}
	/*
	 * store notification settings to config, if changed 
	 */
	if (configuration_changed_fields["tasknotification"]) {
		configSetKey("modules.tasks.notifyNewModifiedDeleted",getBoolofInt(getValueofRadioBox("cs_tasknotification_0")));	
		configSetKey("modules.tasks.notifyAcceptedDeclinedAsCreator",getBoolofInt(getValueofRadioBox("cs_tasknotification_1")));
		configSetKey("modules.tasks.notifyAcceptedDeclinedAsParticipant",getBoolofInt(getValueofRadioBox("cs_tasknotification_2")));
	}
	triggerEvent("OX_Save_Configuration",false,false);
}
function ct_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	ct_enter();
}
function ct_leave() {
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

registerView("configuration/infostore/preferences",
	function () { 
		showNode("config_infostore"); 
		$("config_infostore").style.display="block"; },
	function() { 
		register("OX_SAVE_OBJECT",ci_saveConfiguration);
		register("OX_Cancel_Object",ci_cancelConfiguration);
		ci_enter(); },
	function() {
		//configuration_askforSave();
		unregister("OX_SAVE_OBJECT",ci_saveConfiguration);
		unregister("OX_Cancel_Object",ci_cancelConfiguration);
		ci_leave();
	},
	function () { 
		hideNode("config_infostore"); 
		$("config_infostore").style.display="none"; },
	function() {
		ci_enter();
	}
);

var ci_init_bool=false;
var ci_default_level1;
register("OX_Configuration_Loaded",ci_onconfigload);
function ci_onconfigload() {
	addDefaultView("infostore/list","List view"); /*i18n*/
	addDefaultView("infostore/split","H-split view"); /*i18n*/
}
function ci_init() {
	ci_default_level1= new ComboBox3(window, "ci_default_level1", "16em", 1, true,"OX_Configuration_GUI_Changed", 5);
	var conviews=getDefaultSubviews("infostore");
	for (var i in conviews) {
		ci_default_level1.addElement(conviews[i],i);
	}
	ci_default_level1.getDomNode();
}
function ci_enter() {
	if(!ci_init_bool) {
		ci_init();
		ci_init_bool=true;
	}
	if(configContainsKey("gui.infostore.view")) {
		ci_default_level1.setKey(configGetKey("gui.infostore.view"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.infostore")) {
		setIntofRadioBox("ci_enablehoverinfostore",configGetKey("gui.effects.hover.infostore"));
		configuration_changed_fields["gui"]=false;
	}
	$("ci_header").firstChild.nodeValue=getconfigPathSelected().substring(1);		
		
}
function ci_saveConfiguration() {
	if(configuration_changed_fields["gui"]==true) {
		configSetKey("gui.infostore.view",ci_default_level1.getKey());
		menulastviews["infostore"]=ci_default_level1.getKey();
		configSetKey("gui.effects.hover.infostore",getBoolofInt(getValueofRadioBox("ci_enablehoverinfostore")));
	}
	triggerEvent("OX_Save_Configuration",false,false);
}
function ci_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	ci_enter();
}
function ci_leave() {
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

registerView("configuration/portal/layout",
	function () { 
		showNode("config_portal"); 
		$("config_portal").style.display="block"; },
	function() { 
		register("OX_SAVE_OBJECT",cp_saveConfiguration);
		register("OX_Cancel_Object",cp_cancelConfiguration);
		
		cp_enter();
	},
	function() {
		//configuration_askforSave();
		unregister("OX_SAVE_OBJECT",cp_saveConfiguration);
		unregister("OX_Cancel_Object",cp_cancelConfiguration);		
		cp_leave();
	},
	function () { 
		hideNode("config_portal"); 
		$("config_portal").style.display="none"; },
	function () { cp_enter();}
);

var cp_init_bool=false;
var cp_internalcontents=new Object();
var config_portal_mail;
var config_portal_calendar;
var config_portal_infostore;
var config_portal_tasks;

function cp_saveConfiguration() {
	if(configuration_changed_fields["gui"]) {
		config_portal_fillContents();
		configSetKey("gui.portal.internalcontents",cp_internalcontents);
		configSetKey("gui.effects.hover.portal",getBoolofInt(getValueofRadioBox("config_portal_enablehoverportal")));
	}
	bPortalConfigChanged = true;
	triggerEvent("OX_Save_Configuration",false,false);
}
function cp_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	cp_enter();	
}
function cp_init() {
	config_portal_mail=new ComboBox3(window, "config_portal_mail", "15em", 0, true,"OX_Configuration_Settings_Changed_GUI", null);
	config_portal_mail.addElement("Hide",0);/*i18n*/
	config_portal_mail.addElement("Show 5 elements",5);/*i18n*/
	config_portal_mail.addElement("Show 10 elements",10);/*i18n*/
	config_portal_mail.addElement("Show 15 elements",15);/*i18n*/
	config_portal_mail.addElement("Show 20 elements",20);/*i18n*/
	config_portal_mail.getDomNode();
	if(!configGetKey("modules.mail.module")) {
		config_portal_mail.disable();
	}
	
	config_portal_calendar=new ComboBox3(window, "config_portal_calendar", "15em", 0, true,"OX_Configuration_Settings_Changed_GUI", null);
	config_portal_calendar.addElement("Hide module window",0);/*i18n*/
	config_portal_calendar.addElement("Show 5 elements",5);
	config_portal_calendar.addElement("Show 10 elements",10);
	config_portal_calendar.addElement("Show 15 elements",15);
	config_portal_calendar.addElement("Show 20 elements",20);
	config_portal_calendar.getDomNode();
	if(!configGetKey("modules.calendar.module")) {
		config_portal_calendar.disable();
	}
	
	config_portal_infostore=new ComboBox3(window, "config_portal_infostore", "15em", 0, true,"OX_Configuration_Settings_Changed_GUI", null);
	config_portal_infostore.addElement("Hide",0);
	config_portal_infostore.addElement("Show 5 elements",5);
	config_portal_infostore.addElement("Show 10 elements",10);
	config_portal_infostore.addElement("Show 15 elements",15);
	config_portal_infostore.addElement("Show 20 elements",20);
	config_portal_infostore.getDomNode();
	if(!configGetKey("modules.infostore.module")) {
		config_portal_infostore.disable();
	}

	config_portal_tasks=new ComboBox3(window, "config_portal_tasks", "15em", 0, true,"OX_Configuration_Settings_Changed_GUI", null);
	config_portal_tasks.addElement("Hide module window",0);/*i18n*/
	config_portal_tasks.addElement("Show 5 elements",5);/*i18n*/
	config_portal_tasks.addElement("Show 10 elements",10);/*i18n*/
	config_portal_tasks.addElement("Show 15 elements",15);/*i18n*/
	config_portal_tasks.addElement("Show 20 elements",20);/*i18n*/
	config_portal_tasks.getDomNode();
	if(!configGetKey("modules.tasks.module")) {
		config_portal_tasks.disable();
	}
}
function cp_leave() {	
}
register("OX_Configuration_Loaded",function() {
	var cp_internalcontents=new Array();
    if(configContainsKey("gui.portal.internalcontents")) {
		cp_internalcontents=configGetKey("gui.portal.internalcontents");
		if(!cp_internalcontents.push) {
			cp_internalcontents=new Array();
		}		
	}
	for(var i in modulesview) {
		var temp1=false;
		for(var i2=0;i2<cp_internalcontents.length;i2++) {
			if(cp_internalcontents[i2].module==modulesview[i].name) {
				if(!cp_internalcontents[i2].adj || !cp_internalcontents[i2].adj.ww) { cp_internalcontents[i2].adj=modulesview[i].adj; }
				temp1=true;
			}
		}
		if(!temp1) {
			var tmp =new Object();
			tmp.external=false;
			tmp.module=modulesview[i].name;
			tmp.header=modulesview[i].text;
			tmp.visible=true;
			tmp.params=new Object();
			tmp.params.limit=modulesview[i].limit;	
			tmp.adj=modulesview[i].adj;
			cp_internalcontents.push(tmp);
		}
	}
	for(var indx=0;indx<cp_internalcontents.length;indx++)	
	{
		if(!configGetKey("modules."+cp_internalcontents[indx].module+".module"))		
		{
			cp_internalcontents.splice(indx,1);
		}
	}
	configSetKey("gui.portal.internalcontents",cp_internalcontents);
});
function cp_enter() {
	if(!cp_init_bool) {
		cp_init();
		cp_init_bool=true;
	}
	cp_internalcontents=new Array();
	if(configContainsKey("gui.portal.internalcontents")) {
		cp_internalcontents=configGetKey("gui.portal.internalcontents");
		if(!cp_internalcontents.push) {
			cp_internalcontents=new Array();
		}		
	}
	for (var i=0;i<cp_internalcontents.length;i++) {
		switch(cp_internalcontents[i].module) {
			case "mail":
				if(configGetKey("modules.mail.module")) {
					config_portal_mail.setKey(cp_internalcontents[i].params.limit);
				}
				break;
			case "calendar":
				if(configGetKey("modules.calendar.module")) {
					config_portal_calendar.setKey(cp_internalcontents[i].params.limit);
				}
				break;
			case "tasks":
				if(configGetKey("modules.tasks.module")) {
					config_portal_tasks.setKey(cp_internalcontents[i].params.limit);
				}
				break;
			case "infostore":
				if(configGetKey("modules.infostore.module")) {
					config_portal_infostore.setKey(cp_internalcontents[i].params.limit);
				}
				break;
		}
	}
	if(configContainsKey("gui.effects.hover.portal")) {
		setIntofRadioBox("config_portal_enablehoverportal",configGetKey("gui.effects.hover.portal"));
		configuration_changed_fields["gui"]=false;
	}
	configuration_changed_fields["gui"]=false;
	$("config_portal_header").firstChild.nodeValue=getconfigPathSelected().substring(1);
}
function config_portal_fillContents() {
	
	var mailvalue=config_portal_mail.getKey();
	var calendarvalue=config_portal_calendar.getKey();
	var infostorevalue=config_portal_infostore.getKey();
	var tasksvalue=config_portal_tasks.getKey();
	
	var oldconf=configGetKey("gui.portal.internalcontents");
	for(var i=0;i<oldconf.length;i++) {
		switch(oldconf[i].module) {
			case "calendar":
				if(calendarvalue!=0) { oldconf[i].visible=true; } else { oldconf[i].visible=false; }
				if(!oldconf[i].params) { oldconf[i].params=new Object(); }
				oldconf[i].params.limit=calendarvalue;
				break;
			case "tasks":
				if(tasksvalue!=0) { oldconf[i].visible=true; } else { oldconf[i].visible=false; }
				if(!oldconf[i].params) { oldconf[i].params=new Object(); }
				oldconf[i].params.limit=tasksvalue;
				break;
			case "infostore":
				if(infostorevalue!=0) { oldconf[i].visible=true; } else { oldconf[i].visible=false; }
				if(!oldconf[i].params) { oldconf[i].params=new Object(); }
				oldconf[i].params.limit=infostorevalue;
				break;
			case "mail":
				if(mailvalue!=0) { oldconf[i].visible=true; } else { oldconf[i].visible=false; }
				if(!oldconf[i].params) { oldconf[i].params=new Object(); }
				oldconf[i].params.limit=mailvalue;
				break;

		}
	}
	var myobject=new Object();
	myobject.params=new Object();
	myobject.external=false;
	cp_internalcontents=oldconf;
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
//define dialogue here
function ConfigExternalPortalModules() {
	this.cbok;
	this.cbcancel;
}
ConfigExternalPortalModules.prototype = {
	open : function (){
		showNode("disable_background_window");
		$("disable_background_window").style.display="block";
		showNode("config_popups_win");
		$("config_popups_win").style.display="block";
		try {
			setTimeout(function() { $("external_window_uwa_name").focus() }, 0);
		} catch (e) { }
		showNode("window_external_module");
		centerPopupWindow($("window_external_module"));
		$("window_external_module").style.display="block";		
	},
	close : function (){
		if(this.closecb) { this.closecb(); }
		hideNode("config_popups_win");
		$("config_popups_win").style.display="none";
		hideNode("window_external_module");
		$("window_external_module").style.display="none";
		hideNode("disable_background_window");
		var childs=	$("disable_background_window").childNodes;
		var closeall=true;
		for(var i=0;i<childs.length;i++) {
			if(childs[i].tagName && childs[i].tagName == "DIV") {
				if(childs[i].style.display && childs[i].style.display!= "none" ) {
					closeall=false;
				}
			}
		}
		if(closeall) {
			$("disable_background_window").style.display="none";
		}
	},
	cancel : function (){
		$("external_window_uwa_name").value = "";
		$("external_window_uwa_uri").value = "";	
		$("external_autorefresh").checked = false;
		$("external_standalone").checked = false;		
		$("external_window_uwa_params").value = "";					
		this.close();
	},
	commit : function (){
		add_item();
		$("external_window_uwa_name").value = "";
		$("external_window_uwa_uri").value = "";	
		$("external_autorefresh").checked = false;
		$("external_standalone").checked = false;	
		$("external_window_uwa_params").value = "";			
		this.close();
	}
}
var objExternalPopupWindow = new ConfigExternalPortalModules();

register("Loaded", function () {
		addOnClose($("window_external_module"),function() { objExternalPopupWindow.cancel() }); 
	});
//begin script
var oUWAModulesLG;
var objExternalContRemoved = new Array();
var objExternalContChanged = new Array();
var objExternalContAdded;
var sIdEditExternalUWAPortal = -1;

registerView("configuration/portal/external",
	function () { 
		showNode("config_external"); 
		$("config_external").style.display="block"; 
		//#. The UWA module description at the user options. %s will be replaced with the PMG link.		
		$("config.external.description").innerHTML = format(_(uwaLink.text), ["<a href=\"" + uwaLink.link.format() + "\" target=\"_blank\">", "</a>"]);
	},
	function() { 
		register("OX_SAVE_OBJECT",cpe_saveConfiguration);
		register("OX_Cancel_Object",cpe_cancelConfiguration);
		register("OX_Configuration_External_Portalview_Add",openExternalAddPopup);
		register("OX_Configuration_External_Portalview_Remove",remove_items);		
		register("OX_Configuration_Edit_External",openExternalEditPopup);			
		register("OX_Configuration_Enable_External",enable_items);
		register("OX_Configuration_Disable_External",disable_items);
		cpe_enter();
	},
	function() {
		//configuration_askforSave();
		unregister("OX_SAVE_OBJECT",cpe_saveConfiguration);
		unregister("OX_Cancel_Object",cpe_cancelConfiguration);		
		unregister("OX_Configuration_External_Portalview_Add",openExternalAddPopup);
		unregister("OX_Configuration_External_Portalview_Remove",remove_items);
		unregister("OX_Configuration_Edit_External",openExternalEditPopup);						
		unregister("OX_Configuration_Enable_External",enable_items);
		unregister("OX_Configuration_Disable_External",disable_items);		
		cpe_leave();
	},
	function () { 
		hideNode("config_external"); 
		$("config_external").style.display="none"; 
    },
	function () { cpe_enter();}
);

var cpe_init_bool=false;
var cp_externalcontents=new Object();

function cpe_saveConfiguration() {
	bPortalConfigChanged = true;
	triggerEvent("OX_Save_Configuration",false,false); 
	
}

function cpe_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	cpe_enter();	
}

function cpe_enter(){
	objExternalContAdded = new Array();
	//add_item();
	if(oUWAModulesLG == undefined)
	{
		oUWAModulesLG= new LiveGrid([ 
				{
					index: 1,
                    i18n: "description", /*i18n context*/
					text: "Title", /*i18n*/
					width: "9em",
					set: function  (div, text){
					removeChildNodes(div);
					var sDisplayString =  _(text);
					div.appendChild(document.createTextNode(sDisplayString));	
					},
					clear: LiveGrid.makeClear("...")				
				},
				{
					index: 2,
					text: "URI", /*i18n*/
					i18n: true,				
					set: function  (div, text){
					removeChildNodes(div);
					var sDisplayString =  _(text);
					div.appendChild(document.createTextNode(sDisplayString));	
					},
					clear: LiveGrid.makeClear("...")				
				},
				{
					index: 5,
					text: "Visibility", /*i18n*/
					i18n: true,				
					width: "9em",
					set: function  (div, text){
					removeChildNodes(div);
					var sDisplayString =  (text)?_("enabled"):_("disabled");
					div.appendChild(document.createTextNode(sDisplayString));	
					},
					clear: LiveGrid.makeClear("...")				
				}
			], new Selection());
		oUWAModulesLG.emptylivegridtext="";		
		$("lg_header_uwa_modules").appendChild(oUWAModulesLG.getHeader());
		oUWAModulesLG.getTable($("lg_uwa_modules"));	
		oUWAModulesLG.events.register("Selected",function (ids)
		{

			var aSelectedRows = oUWAModulesLG.selection.getSelected();
			triggerEvent('SubSelected',aSelectedRows.length);		
		});			
		oUWAModulesLG.events.register("Activated",function (ids)
		{

			var aSelectedRows = oUWAModulesLG.selection.getSelected();
			if(aSelectedRows.length > 0)
			{
				triggerEvent('SubSelected',aSelectedRows.length);
				openExternalEditPopup();		
			}
		});					
	}
	setUWALG();
	$("cext_header").firstChild.nodeValue=getconfigPathSelected().substring(1);
}
function setUWALG()
{
	var oStorage = new Storage(0, [],null,null,null,null,function (x){
					return x[0];
		});	
	var oAllWidgts = configGetKey("gui.portal.externalcontents");
	var aData = new Array();
	for (var indx=0;indx<oAllWidgts.length;indx++)
	{
		var oAr = oAllWidgts[indx];
		var sParameterStr = "";
		for(var sKey in oAr["parameter"])
		{
			if(sParameterStr != "")
				sParameterStr += ', ';
			sParameterStr += sKey + ':' + oAr["parameter"][sKey];
		}
		var sUWAId = (oAr["id"])?oAr["id"]:oAr["title"];
		aData.push(new Array(sUWAId,oAr["title"],oAr["url"],oAr["autorefresh"],
															sParameterStr,oAr["visible"],oAr["standalone"]));	
	}
	oStorage.append(aData);	
	oUWAModulesLG.enable(oStorage);					
}

function openExternalEditPopup(){
	objExternalPopupWindow.open();
	var oExternalObj = configGetKey("gui.portal.externalcontents");		
	var aSelectedRows = oUWAModulesLG.selection.getSelected();		
	sIdEditExternalUWAPortal = aSelectedRows[0];
	$("external_window_uwa_name").value = oUWAModulesLG.storage.data.data[aSelectedRows[0]][1];
	$("external_window_uwa_uri").value = oUWAModulesLG.storage.data.data[aSelectedRows[0]][2];	
	$("external_autorefresh").checked = oUWAModulesLG.storage.data.data[aSelectedRows[0]][3];		
	$("external_window_uwa_params").value = oUWAModulesLG.storage.data.data[aSelectedRows[0]][4];
	$("external_standalone").checked = oUWAModulesLG.storage.data.data[aSelectedRows[0]][6];		
}

function openExternalAddPopup(){
	sIdEditExternalUWAPortal = -1;
	objExternalPopupWindow.open();
}
function add_item(){	
	var oData = {	name:$("external_window_uwa_name").value,
					autorefresh:($("external_autorefresh").checked)?true:false,
					url:$("external_window_uwa_uri").value,
					parameter:$("external_window_uwa_params").value,
					standalone:($("external_standalone").checked)?true:false
				};
	if(oData.name.length == 0 || oData.url.length == 0)
	{
		return;
	}
	var sParams = oData.parameter;
	var oParams = new Object();	
	if(sParams != "")
	{
		var aPairs = sParams.split(',');
		var aPairsSplited = new Array();
		for(var nP=0;nP<aPairs.length;nP++)
		{
			 var oCurrPair = aPairs[nP].split(':');
			 oParams[trimStr(oCurrPair[0])] = trimStr(oCurrPair[1]);
			 for(var nIndx=2; nIndx < oCurrPair.length; nIndx++)			 
				 oParams[trimStr(oCurrPair[0])] += (':' + trimStr(oCurrPair[nIndx]));
		}
	}
	var nY = (oPortalObject.matrix.nodes.length-1);
	var nX = (oPortalObject.matrix.nodes[nY].length) + objExternalContAdded.length;	
	var oExternalObj = configGetKey("gui.portal.externalcontents");	

	if(sIdEditExternalUWAPortal == -1)
	{
		var obj = {id: (oData.name+Math.ceil(Math.random() * 1000)), title:oData.name,
									url:oData.url,autorefresh:oData.autorefresh,visible:true,
									standalone:oData.standalone,parameter:oParams,adj:{x:nX,y:nY,ww:1,hw:1}};									
		objExternalContAdded.push(obj);									
		oExternalObj.push(obj);
	}
	else
	{
		for(var nindx=0;nindx<oExternalObj.length;nindx++)
		{
			var sId = (oExternalObj[nindx]["id"])?oExternalObj[nindx]["id"]:oExternalObj[nindx]["title"];
			if(sId == sIdEditExternalUWAPortal)
			{
				if(oExternalObj[nindx]["id"] == undefined)
					oExternalObj[nindx]["id"] =  (oData.name+Math.ceil(Math.random() * 1000));
				oExternalObj[nindx].title = oData.name;
				oExternalObj[nindx].parameter = oParams;				
				oExternalObj[nindx].url = oData.url;			
				oExternalObj[nindx].autorefresh = oData.autorefresh;
				oExternalObj[nindx].standalone = oData.standalone || false;
				objExternalContChanged.push(sId);
				break;
			}
		}
	}
	configSetKey("gui.portal.externalcontents",oExternalObj);
	configuration_changed_fields["gui"]=true;
	setUWALG();										
}

function change_visibility(bEnable)
{
	var oExternalObj = configGetKey("gui.portal.externalcontents");		
	var aSelectedRows = oUWAModulesLG.selection.getSelected();
	for(var nItem in oExternalObj)
	{
		for(var nSel=0;nSel<aSelectedRows.length;nSel++)
		{
			var sId = (oExternalObj[nItem]["id"])?oExternalObj[nItem]["id"]:oExternalObj[nItem]["title"];
			if(sId == aSelectedRows[nSel])
			{
				oExternalObj[nItem]["visible"] = bEnable;
			}
		}
	}
	configSetKey("gui.portal.externalcontents",oExternalObj);
	configuration_changed_fields["gui"]=true;
	setUWALG();
}
function enable_items(){
	change_visibility(true);	
}
function disable_items(){
	change_visibility(false);
}
function remove_items(){
	var sCommText="Are you sure you want to permanently delete the selected UWA modules?"; /*i18n*/
	
	function cbok() {
		var oExternalObj = configGetKey("gui.portal.externalcontents");		
		var aSelectedRows = oUWAModulesLG.selection.getSelected();
		oUWAModulesLG.deleteIDs(aSelectedRows);			
		objExternalContRemoved =  objExternalContRemoved.concat(aSelectedRows);
		for(var nItem in oExternalObj)
		{
			for(var nSel=0;nSel<aSelectedRows.length;nSel++)
			{
				if(oExternalObj[nItem].id == aSelectedRows[nSel])
				{
					oExternalObj.splice(nItem,1);
				}
			}
		}
		configSetKey("gui.portal.externalcontents",oExternalObj);
		configuration_changed_fields["gui"]=true;
	}
	newConfirm(_("Delete UWA Modules"),_(sCommText),AlertPopup.YESNO,null,null,cbok,null,null);	
}
function cpe_leave(){
	oUWAModulesLG.disable();
}
